/*
*
*    RaphaëlSM : Raphaël extension for civil engineering mechanics drawings 
*                                                                             
*                          version 0.9.dev (2014-08-20)                       
*  
*                    Copyright (C)  2011 - 2014  Jan Stransky                 
*  
*           Czech Technical University, Faculty of Civil Engineering,         
*       Department of Structural Mechanics, 166 29 Prague, Czech Republic     
*  
*  RaphaëlSM is free software: you can redistribute it and/or modify it under
*  the terms of the GNU Lesser General Public License as published by the Free
*  Software Foundation, either version 3 of the License, or (at your option)
*  any later version.
*  
*  RaphaëlSM is distributed in the hope that it will be useful, but WITHOUT
*  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
*  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
*  for more details.
*  
*  You should have received a copy of the GNU Lesser General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
var RaphaelSM={};
Raphael.fn.GeomObj=function(b){b=void 0==b?{}:b;var c=this.path();c.x=void 0==b.x?0:b.x;c.y=void 0==b.y?0:b.y;c.size=void 0==b.size?1:b.size;c.angle=void 0==b.angle?0:b.angle;c.pathList=null;c.copies=[];c.copiesShifts=[];c.sin=function(){return Math.sin(-Raphael.rad(this.angle))};c.cos=function(){return Math.cos(-Raphael.rad(this.angle))};c.setPathList=function(){};c.setXY=function(a,b){this.x=a;this.y=b;this.update()};c.setX=function(a){this.x=a;this.update()};c.setY=function(a){this.y=a;this.update()};
c.translateXY=function(a,b){this.x+=a;this.y+=b;this.update()};c.translateX=function(a){this.translateXY(a,0)};c.translateY=function(a){this.translateXY(0,a)};c.rotate=function(a){this.angle+=a;this.update()};c.setAngle=function(a){this.angle=a;this.update()};c.copy=function(a){for(var b=0;b<a.length;b++)this.copiesShifts.push(a[b]),this.copies.push(this.makeCopy()),this.update()};c.makeCopy=function(){};c.update=function(){this.setPathList();this.attr({path:this.pathList});for(var a=0;a<this.copies.length;a++)this.copies[a].setXY(this.x+
this.copiesShifts[a][0],this.y+this.copiesShifts[a][1])};return c};
Raphael.fn.Arrow=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b);void 0==b.size&&(c.size=50);c.headLen=void 0==b.headLen?c.size/4:b.headLen;c.headWidth=void 0==b.headWidth?c.size/16:b.headWidth;c.style=void 0==b.style?0:b.style;c.setPathList=function(){var a=this.sin(),b=this.cos();switch(this.style){case 1:this.pathList=[["M",this.x,this.y],["L",this.x+b*this.size,this.y+a*this.size],["M",this.x+b*this.headLen-a*this.headWidth,this.y+a*this.headLen+b*this.headWidth],["L",this.x,this.y],["L",this.x+
b*this.headLen+a*this.headWidth,this.y+a*this.headLen-b*this.headWidth]];break;default:this.pathList=[["M",this.x+b*this.headLen*0.8,this.y+a*this.headLen*0.8],["L",this.x+b*this.size,this.y+a*this.size],["M",this.x+b*this.headLen*0.8,this.y+a*this.headLen*0.8],["L",this.x+b*this.headLen-a*this.headWidth,this.y+a*this.headLen+b*this.headWidth],["L",this.x,this.y],["L",this.x+b*this.headLen+a*this.headWidth,this.y+a*this.headLen-b*this.headWidth],["Z"]]}};c.resize=function(a){this.show();1>Math.abs(a)?
this.hide():(this.headLen*=a/this.size,this.headWidth*=a/this.size,this.size=a,this.update())};c.makeCopy=function(){var a=this.paper.Arrow({x:this.x,y:this.y,size:this.size,angle:this.angle,headLen:this.headLen,headWidth:this.headWidth,style:this.style});a.attr(this.attr());a.update();return a};c.update();return c};
Raphael.fn.PinSupport=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b);void 0==b.size&&(c.size=20);c.sliding=void 0==b.sliding?!1:b.sliding;c.ratio=void 0==b.ratio?0.7:b.ratio;c.gap=void 0==b.gap?5:b.gap;c.setPathList=function(){var a=this.sin(),b=this.cos();this.pathList=this.sliding?[["M",this.x,this.y],["L",this.x-b*this.ratio*this.size-a*this.size,this.y-a*this.ratio*this.size+b*this.size],["L",this.x+b*this.ratio*this.size-a*this.size,this.y+a*this.ratio*this.size+b*this.size],["Z"],["M",this.x-
b*this.ratio*this.size-a*(this.size+this.gap),this.y-a*this.ratio*this.size+b*(this.size+this.gap)],["L",this.x+b*this.ratio*this.size-a*(this.size+this.gap),this.y+a*this.ratio*this.size+b*(this.size+this.gap)]]:[["M",this.x,this.y],["L",this.x-b*this.ratio*this.size-a*this.size,this.y-a*this.ratio*this.size+b*this.size],["L",this.x+b*this.ratio*this.size-a*this.size,this.y+a*this.ratio*this.size+b*this.size],["Z"]]};c.makeCopy=function(){var a=this.paper.PinSupport({x:this.x,y:this.y,size:this.size,
angle:this.angle,sliding:this.sliding,gap:this.gap,ratio:this.ratio});a.attr(this.attr());return a};c.update();return c};
Raphael.fn.FixedSupport=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b);void 0==b.size&&(c.size=30);c.ratio=void 0==b.ratio?0.2:b.ratio;c.nFlags=void 0==b.nFlags?5:b.nFlags;c.reversed=void 0==b.reversed?!1:b.reversed;c.setPathList=function(){var a=this.sin(),b=this.cos();this.pathList=[["M",this.x-a*this.size*0.5,this.y+b*this.size*0.5],["L",this.x+a*this.size*0.5,this.y-b*this.size*0.5]];if(this.reversed)for(var c=0;c<this.nFlags;c++){var f=RaphaelTools.vecTrans(0,this.size*(-0.5+(c+1)/this.nFlags),
a,b),e=RaphaelTools.vecTrans(-this.size*this.ratio,this.size*(-0.5+c/this.nFlags),a,b);this.pathList.push(["M",this.x+f[0],this.y+f[1]]);this.pathList.push(["L",this.x+e[0],this.y+e[1]])}else for(c=0;c<this.nFlags;c++)f=RaphaelTools.vecTrans(0,this.size*(-0.5+c/this.nFlags),a,b),e=RaphaelTools.vecTrans(-this.size*this.ratio,this.size*(-0.5+(c+1)/this.nFlags),a,b),this.pathList.push(["M",this.x+f[0],this.y+f[1]]),this.pathList.push(["L",this.x+e[0],this.y+e[1]])};c.makeCopy=function(){var a=this.paper.FixedSupport({x:this.x,
y:this.y,size:this.size,angle:this.angle,ratio:this.ratio,nFlags:this.nFlags,reversed:this.reversed});a.attr(this.attr());a.update();return a};c.update();return c};
Raphael.fn.DistributedLoad=function(b,c,a){var d=this.path();d.point1=b;d.point2=c;a=void 0==a?{}:a;d.valx=void 0==a.valx?0:a.valx;d.valy=void 0==a.valy?0:a.valy;d.nArrows=void 0==a.nArrows?4:a.nArrows;d.style=void 0==a.style?0:a.style;d.closed=void 0==a.closed?!1:a.closed;d.setVals=function(a,b){this.valx=void 0==a?0:a;this.valy=void 0==b?0:b;this.update()};d.setPathList=function(){var a=this.point1.x,b=this.point1.y,d=this.point2.x,c=this.point2.y,l=d-a,m=c-b,g=Math.sqrt(l*l+m*m),l=l/g,m=m/g,k=
Math.sqrt(this.valx*this.valx+this.valy*this.valy);if(1>Math.abs(k))this.hide();else{this.show();var n=this.valx/k,p=this.valy/k;this.pathList=[["M",a,b],["L",a-this.valx,b-this.valy],["M",a-this.valx,b-this.valy],["L",d-this.valx,c-this.valy],["M",d-this.valx,c-this.valy],["L",d,c]];this.closed&&(this.pathList.push(["M",d,c]),this.pathList.push(["L",a,b]));d=Math.round(this.nArrows);g/=d+1;for(c=1;c<=d;c++)switch(this.style){case 1:this.pathList.push(["M",a-this.valx+c*g*l,b-this.valy+c*g*m],["L",
a+c*g*l,b+c*g*m],["M",a+c*g*l-n*k/4+p*k/16,b+c*g*m-p*k/4-n*k/16],["L",a+c*g*l,b+c*g*m],["L",a+c*g*l-n*k/4-p*k/16,b+c*g*m-p*k/4+n*k/16]);break;default:this.pathList.push(["M",a-this.valx+c*g*l,b-this.valy+c*g*m],["L",a+c*g*l-0.8*n*k/4,b+c*g*m-0.8*p*k/4],["M",a+c*g*l-0.8*n*k/4,b+c*g*m-0.8*p*k/4],["L",a+c*g*l-n*k/4+p*k/16,b+c*g*m-p*k/4-n*k/16],["L",a+c*g*l,b+c*g*m],["L",a+c*g*l-n*k/4-p*k/16,b+c*g*m-p*k/4+n*k/16],["Z"])}}};d.update=function(){this.setPathList();this.attr({path:this.pathList})};d.update();
return d};
Raphael.fn.CurveObj=function(b,c,a){a=void 0==a?{}:a;var d=this.path();d.point1=b;d.point2=c;d.scale=void 0==a.scale?1:a.scale;d.closedBegin=void 0==a.closedBegin?!0:a.closedBegin;d.closedEnd=void 0==a.closedEnd?!0:a.closedEnd;d.closedBase=void 0==a.closedBase?!0:a.closedBase;d.curve=this.path().hide();d.consts=function(){};d.setPathList=function(){};d.setGeom=function(){this.x1=this.point1.x;this.y1=this.point1.y;this.x2=this.point2.x;this.y2=this.point2.y;var a=this.x2-this.x1,b=this.y2-this.y1;
this.len=Math.sqrt(a*a+b*b);this.segLen=this.len/this.nSeg||1;1E-12>Math.abs(this.len)?(this.cos=1,this.sin=0):(this.cos=a/this.len,this.sin=b/this.len)};d.update=function(){this.setGeom();this.consts();this.setPathList();this.attr({path:this.pathList});this.curve.attr({path:this.pathList})};d.closedPartsHandle=function(a){this.closedEnd?this.pathList.push(["L",this.x2,this.y2]):this.pathList.push(["M",this.x2,this.y2]);this.closedBase?this.pathList.push(["L",this.x1,this.y1]):this.pathList.push(["M",
this.x1,this.y1]);this.closedBegin&&this.pathList.push(["L",this.x1-this.scale*this.sin*a,this.y1+this.scale*this.cos*a])};d.update();return d};
Raphael.fn.ConstantCurve=function(b,c,a){a=void 0==a?{}:a;b=this.CurveObj(b,c,a);b.val=void 0==a.val?0:a.val;b.setPathList=function(){this.pathList=[["M",this.x1-this.scale*this.sin*this.val,this.y1+this.scale*this.cos*this.val]];this.pathList.push(["L",this.x2-this.scale*this.sin*this.val,this.y2+this.scale*this.cos*this.val]);this.closedPartsHandle(this.val)};b.setVal=function(a){this.val=a;this.update()};b.update();return b};
Raphael.fn.LinearCurve=function(b,c,a){a=void 0==a?{}:a;b=this.CurveObj(b,c,a);b.val1=void 0==a.val1?0:a.val1;b.val2=void 0==a.val2?0:a.val2;b.setPathList=function(){this.pathList=[["M",this.x1-this.scale*this.sin*this.val1,this.y1+this.scale*this.cos*this.val1]];this.pathList.push(["L",this.x2-this.scale*this.sin*this.val2,this.y2+this.scale*this.cos*this.val2]);this.closedPartsHandle(this.val1)};b.setVals=function(a,b){this.val1=a;this.val2=b;this.update()};b.update();return b};
Raphael.fn.ParabolicCurve=function(b,c,a){a=void 0==a?{}:a;b=this.CurveObj(b,c,a);b.val1=void 0==a.val1?0:a.val1;b.valMid=void 0==a.valMid?0:a.valMid;b.val2=void 0==a.val2?0:a.val2;b.nSeg=void 0==a.nSeg?5:a.nSeg;b.consts=function(){this.c0=this.val1;this.c1=(-3*this.val1-this.val2+4*this.valMid)/this.len;this.c2=(2*this.val1+2*this.val2-4*this.valMid)/this.len/this.len};b.v=function(a){return this.c0+this.c1*a+this.c2*a*a};b.dv=function(a){return this.c1+2*this.c2*a};b.setPathList=function(){this.pathList=
[["M",this.x1-this.scale*this.sin*this.v(0),this.y1+this.scale*this.cos*this.v(0)]];for(var a=0;a<this.nSeg;a++){var b=this.v(a*this.segLen),c=this.v((a+1)*this.segLen),e=this.dv(a*this.segLen),h=this.dv((a+1)*this.segLen),b=RaphaelTools.vecTrans((a+0.3)*this.segLen,this.scale*(b+0.3*e*this.segLen),this.sin,this.cos),h=RaphaelTools.vecTrans((a+1-0.3)*this.segLen,this.scale*(c-0.3*h*this.segLen),this.sin,this.cos),c=RaphaelTools.vecTrans((a+1)*this.segLen,this.scale*c,this.sin,this.cos);this.pathList.push(["C",
this.x1+b[0],this.y1+b[1],this.x1+h[0],this.y1+h[1],this.x1+c[0],this.y1+c[1]])}this.closedPartsHandle(this.v(0))};b.setVals=function(a,b,c){this.val1=a;this.val2=b;this.valMid=c;this.update()};b.update();return b};
Raphael.fn.DeflCurve=function(b,c,a){a=void 0==a?{}:a;b=this.CurveObj(b,c,a);b.closedBegin=void 0==a.closedBegin?!1:a.closedBegin;b.closedEnd=void 0==a.closedEnd?!1:a.closedEnd;b.closedBase=void 0==a.closedBase?!1:a.closedBase;b.u1=void 0==a.u1?0:a.u1;b.w1=void 0==a.w1?0:a.w1;b.phi1=void 0==a.phi1?0:a.phi1;b.u2=void 0==a.u2?0:a.u2;b.w2=void 0==a.w2?0:a.w2;b.phi2=void 0==a.phi2?0:a.phi2;b.wMid=void 0==a.wMid?0:a.wMid;b.realLen=void 0==a.realLen?1:a.realLen;b.nSeg=void 0==a.nSeg?5:a.nSeg;b.scale=void 0==
a.scale?1:a.scale;a=b.point1.x-b.point2.x;c=b.point1.y-b.point2.y;a=Math.sqrt(a*a+c*c);b.lenScale=b.realLen/a;b.consts=function(){this.c0=this.w1;this.c1=-this.phi1*this.lenScale;this.c2=(2*this.phi1+this.phi2)*this.lenScale/this.len+3/this.len/this.len*(this.w2-this.w1)+16/this.len/this.len*this.wMid;this.c3=2/this.len/this.len/this.len*(this.w1-this.w2)-1/this.len/this.len*this.lenScale*(this.phi1+this.phi2)-32/this.len/this.len/this.len*this.wMid;this.c4=16/this.len/this.len/this.len/this.len*
this.wMid};b.w=function(a){return this.c0+this.c1*a+this.c2*a*a+this.c3*a*a*a+this.c4*a*a*a*a};b.dw=function(a){return this.c1+2*this.c2*a+3*this.c3*a*a+4*this.c4*a*a*a};b.setPathList=function(){this.pathList=[["M",this.x1+this.scale*(this.u1*this.cos-this.sin*this.w(0)),this.y1+this.scale*(this.u1*this.sin+this.cos*this.w(0))]];for(var a=0;a<this.nSeg;a++){var b=this.w(a*this.segLen),c=this.w((a+1)*this.segLen),e=this.dw(a*this.segLen),h=this.dw((a+1)*this.segLen),b=RaphaelTools.vecTrans(this.scale*
this.u1+(a+0.3)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*(b+0.3*e*this.segLen),this.sin,this.cos),h=RaphaelTools.vecTrans(this.scale*this.u1+(a+1-0.3)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*(c-0.3*h*this.segLen),this.sin,this.cos),c=RaphaelTools.vecTrans(this.scale*this.u1+(a+1)*(this.segLen+this.scale*(this.u2-this.u1)/this.nSeg),this.scale*c,this.sin,this.cos);this.pathList.push(["C",this.x1+b[0],this.y1+b[1],this.x1+h[0],this.y1+h[1],this.x1+c[0],
this.y1+c[1]])}this.closedPartsHandle(this.w(0))};b.setDsplFull=function(a,b,c,e,h,l,m){this.u1=a;this.w1=b;this.phi1=c;this.u2=e;this.w2=h;this.phi2=l;this.wMid=m||0;this.update()};b.update();return b};Raphael.fn.DeflCubic=function(b,c,a){a=void 0==a?{}:a;b=this.DeflCurve(b,c,a);b.wMid=void 0==a.wMid?0:a.wMid;b.setDspl=function(a,b,c,e,h,l){this.setDsplFull(a,b,c,e,h,l,0)};b.update();return b};
Raphael.fn.Defl4thOrder=function(b,c,a){a=void 0==a?{}:a;b=this.DeflCurve(b,c,a);b.setDspl=function(a,b,c,e,h,l,m){this.setDsplFull(a,b,c,e,h,l,m)};b.update();return b};Raphael.fn.DeflCubicNoU=function(b,c,a){a=void 0==a?{}:a;a.wMid=0;a.u1=0;a.u2=0;b=this.DeflCurve(b,c,a);b.setDspl=function(a,b,c,e){this.setDsplFull(0,a,b,0,c,e,0)};b.update();return b};
Raphael.fn.Defl4thOrderNoU=function(b,c,a){a=void 0==a?{}:a;a.u1=0;a.u2=0;b=this.DeflCurve(b,c,a);b.setDspl=function(a,b,c,e,h){this.setDsplFull(0,a,b,0,c,e,h)};b.update();return b};
RaphaelSM.Dimension=function(b,c,a,d){this.point1=c;this.point2=a;d=void 0==d?{}:d;this.type=void 0==d.type?"c":"e"==d.type?"e":"c";this.height=void 0==d.height?30:d.height;this.overhang=void 0==d.overhang?6:d.overhang;this.offset=void 0==d.offset?10:d.offset;this.arrowSize=void 0==d.arrowSize?this.overhang:d.arrowSize;this.textOffset=void 0==d.textOffset?12:d.textOffset;this.val=void 0==d.val?"":d.val;this.threshold=void 0==d.threshold?1:d.threshold;this.lower=void 0==d.lower?!0:d.lower;c=void 0==
d.pathAttrs?{}:d.pathAttrs;this.path=b.path().attr(c);d=void 0==d.textAttrs?{}:d.textAttrs;"e"==this.type&&(d["arrow-end"]="classic-midium-long");this.text=b.text(0,0,this.val).attr({"font-size":20}).attr(d);this.pathList=[]};
RaphaelSM.Dimension.prototype.update=function(){var b=this.point2.x-this.point1.x,c=this.point2.y-this.point1.y,a=Math.sqrt(b*b+c*c);this.show();if(a<this.threshold)this.hide();else{var d=this.lower?1:-1,b=b/a,c=c/a,a=d*this.offset,q=a+d*this.height,f=q+d*this.overhang,e=this.overhang;this.pathList=[["M",this.point1.x-c*a,this.point1.y+b*a],["L",this.point1.x-c*f,this.point1.y+b*f],["M",this.point2.x-c*a,this.point2.y+b*a],["L",this.point2.x-c*f,this.point2.y+b*f],["M",this.point1.x-c*q,this.point1.y+
b*q],["L",this.point2.x-c*q,this.point2.y+b*q]];"c"==this.type&&(a=q+this.arrowSize,f=q-this.arrowSize,this.pathList.push(["M",this.point1.x-c*a-b*e,this.point1.y+b*a-c*e]),this.pathList.push(["L",this.point1.x-c*f+b*e,this.point1.y+b*f+c*e]),this.pathList.push(["M",this.point2.x-c*a-b*e,this.point2.y+b*a-c*e]),this.pathList.push(["L",this.point2.x-c*f+b*e,this.point2.y+b*f+c*e]));this.path.attr({path:this.pathList});f=this.offset+this.height-d*this.textOffset;e=0.5*(this.point1.x+this.point2.x)-
d*c*f;a=0.5*(this.point1.y+this.point2.y)+d*b*f;d=180*Math.acos(b)/Math.PI;0>c&&(d=360-d);this.text.attr({transform:"t"+e+","+a+"r"+d,text:this.val});this.text.attr({x:+e,y:a,transform:"r"+d,text:this.val})}};RaphaelSM.Dimension.prototype.setVal=function(b){this.val=b;this.update()};RaphaelSM.Dimension.prototype.hide=function(){this.path.hide();this.text.hide()};RaphaelSM.Dimension.prototype.show=function(){this.path.show();this.text.show()};
RaphaelSM.Dimension.create=function(b,c,a,d){b=new RaphaelSM.Dimension(b,c,a,d);b.update();return b};
Raphael.fn.Spring=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b).attr({"stroke-linejoin":"miter","stroke-miterlimit":1E3});void 0==b.size&&(c.size=100);c.size=void 0==b.size?200:b.size;c.width=void 0==b.width?40:b.width;c.offset=void 0==b.offset?20:b.offset;c.num=void 0==b.num?14:b.num;c.setPathList=function(){var a=this.sin(),b=this.cos(),c=Array(2*this.num+3);c[0]=["M",this.x,this.y];c[1]=["l",this.offset*b,this.offset*a];for(var f=(this.size-2*this.offset)/this.num*0.5,e,h=0;h<this.num;h++)e=
0.5*this.width*Math.pow(-1,h),c[2+2*h]=["l",f*b-e*a,f*a+e*b],c[2*h+3]=["l",f*b+e*a,f*a-e*b];c[2*this.num+2]=["L",this.x+b*this.size,this.y+a*this.size];this.pathList=c};c.makeCopy=function(){var a=this.paper.Spring({x:this.x,y:this.y,size:this.size,angle:this.angle,width:this.width,offset:this.offset,num:this.num});a.attr(this.attr());return a};c.resize=function(a){this.size=a;this.update()};c.update();return c};
Raphael.fn.Dashpot=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b);void 0==b.size&&(c.size=100);c.size=void 0==b.size?200:b.size;c.width=void 0==b.width?40:b.width;c.offset=void 0==b.offset?20:b.offset;c.dspl=void 0==b.dspl?0:b.dspl;c.dw=void 0==b.dw?5:b.dw;c.setPathList=function(){var a=this.sin(),b=this.cos(),c=0.66667*(this.size-this.offset),f=0.5*this.width;this.pathList=[["M",this.x,this.y],["l",this.offset*b,this.offset*a],["l",-f*a,f*b],["l",c*b,c*a],["M",this.x+this.offset*b,this.y+this.offset*
a],["l",+f*a,-f*b],["l",c*b,c*a],["M",this.x+b*(this.offset+0.5*c+this.dspl)-a*(f-this.dw),this.y+a*(this.offset+0.5*c+this.dspl)+b*(f-this.dw)],["l",2*(f-this.dw)*a,-2*(f-this.dw)*b],["M",this.x+b*(this.offset+0.5*c+this.dspl),this.y+a*(this.offset+0.5*c+this.dspl)],["l",c*b,c*a]]};c.makeCopy=function(){var a=this.paper.Dashpot({x:this.x,y:this.y,size:this.size,angle:this.angle,width:this.width,offset:this.offset,dspl:this.dspl,dw:this.dw});a.attr(this.attr());return a};c.resize=function(a){this.size=
a;this.update()};c.update();return c};
Raphael.fn.PlasticElement=function(b){b=void 0==b?{}:b;var c=this.GeomObj(b);void 0==b.size&&(c.size=100);c.size=void 0==b.size?200:b.size;c.width=void 0==b.width?10:b.width;c.offset=void 0==b.offset?10:b.offset;c.dspl=void 0==b.dspl?0:b.dspl;c.setPathList=function(){var a=this.sin(),b=this.cos(),c=this.size,f=0.66667*(c-this.offset),e=this.width;this.pathList=[["M",this.x,this.y],["l",f*b,f*a],["l",0.7*b*-e-a*e,0.7*a*-e+b*e],["l",0.7*b*-e-a*-e,0.7*a*-e+b*-e],["M",this.x+(c+this.dspl)*b,this.y+(c+
this.dspl)*a],["l",b*-this.offset,a*-this.offset],["m",0,0],["l",0.7*b*-e-a*e,0.7*a*-e+b*e],["m",0,0],["l",b*-f,a*-f]]};c.makeCopy=function(){var a=this.paper.PlasticElement({x:this.x,y:this.y,size:this.size,angle:this.angle,width:this.width,offset:this.offset,dspl:this.dspl,dw:this.dw});a.attr(this.attr());return a};c.resize=function(a){this.size=a;this.update()};c.update();return c};
