/*
*
*             JSMatrix : JavaScript matrix and vector implementation          
*                                                                             
*                          version 0.9.dev (2014-08-20)                       
*  
*                    Copyright (C)  2011 - 2014  Jan Stransky                 
*  
*           Czech Technical University, Faculty of Civil Engineering,         
*       Department of Structural Mechanics, 166 29 Prague, Czech Republic     
*  
*  JSMatrix is free software: you can redistribute it and/or modify it under
*  the terms of the GNU Lesser General Public License as published by the Free
*  Software Foundation, either version 3 of the License, or (at your option)
*  any later version.
*  
*  JSMatrix is distributed in the hope that it will be useful, but WITHOUT ANY
*  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
*  FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for
*  more details.
*  
*  You should have received a copy of the GNU Lesser General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
var JSMatrix={X:0,Y:1,Z:2,TOL:1E-8,TOL2:1E-32,Vector:function(a){this.nElements=a||0;for(a=0;a<this.nElements;a++)this[a]=0},Matrix:function(a,b){this.nRows=a||0;this.nCols=b||0;var c,d;for(c=0;c<this.nRows;c++)for(this[c]={},d=0;d<this.nCols;d++)this[c][d]=0}};JSMatrix.Vector.prototype.empty=function(){this.resize(0)};JSMatrix.Vector.prototype.isEmpty=function(){return 0==this.nElements};JSMatrix.Vector.prototype.zero=function(){for(var a=0;a<this.nElements;a++)this[a]=0};
JSMatrix.Vector.prototype.beFullOfOnes=function(){for(var a=0;a<this.nElements;a++)this[a]=1};JSMatrix.Vector.prototype.one=JSMatrix.Vector.prototype.beFullOfOnes;JSMatrix.Vector.prototype.size=function(){return this.nElements};JSMatrix.Vector.prototype.sum=function(){for(var a=0,b=0;b<this.nElements;b++)a+=this[b];return a};JSMatrix.Vector.prototype.max=function(){for(var a=-1E64,b=0;b<this.nElements;b++)this[b]>a&&(a=this[b]);return a};
JSMatrix.Vector.prototype.min=function(){for(var a=1E64,b=0;b<this.nElements;b++)this[b]<a&&(a=this[b]);return a};JSMatrix.Vector.prototype.abs=function(){for(var a=new JSMatrix.Vector(this.nElements),b=0;b<this.nElements;b++)a[b]=Math.abs(this[b]);return a};JSMatrix.Vector.prototype.indexOf=function(a){for(var b=0;b<this.nElements;b++)if(Math.abs(this[b]-a)<JSMatrix.TOL)return b;return null};
JSMatrix.Vector.prototype.isEqualTo=function(a){if(!this.isSameSizeAs(a))return!1;for(var b=0;b<this.nElements;b++)if(Math.abs(this[b]-a[b])>JSMatrix.TOL)return!1;return!0};JSMatrix.Vector.prototype.get=function(a){return 0>a||a>=this.nElements?null:this[a]};JSMatrix.Vector.prototype.set=function(a,b){0>a||a>=this.nElements||(this[a]=b)};JSMatrix.Vector.prototype.incr=function(a,b){0>a||a>=this.nElements||b&&(this[a]+=b)};JSMatrix.Vector.prototype.isSameSizeAs=function(a){return this.nElements==a.nElements};
JSMatrix.Vector.prototype.canMultiplyMat=function(a){return this.nElements==a.nCols};JSMatrix.Vector.canMultiplyMatFromLeft=JSMatrix.Vector.prototype.canMultiplyMat;JSMatrix.Vector.prototype.fromArray=function(a){var b=a.length,c;for(c=0;c<b;c++)this[c]=a[c];for(c=b;c<this.nElements;c++)delete this[c];this.nElements=b};JSMatrix.Vector.prototype.toArray=function(){for(var a=[],b=0;b<this.nElements;b++)a[b]=this[b];return a};
JSMatrix.Vector.prototype.add=function(a){if(!this.isSameSizeAs(a))return null;for(var b=new JSMatrix.Vector,c=0;c<this.nElements;c++)b[c]=this[c]+a[c];b.nElements=this.nElements;return b};JSMatrix.Vector.prototype.iadd=function(a){if(this.isSameSizeAs(a))for(var b=0;b<this.nElements;b++)this[b]+=a[b]};JSMatrix.Vector.prototype.beSumOf=function(a,b){if(a.isSameSizeAs(b)){var c,d=a.nElements;for(c=0;c<d;c++)this[c]=a[c]+b[c];for(c=d;c<this.nElements;c++)delete this[c];this.nElements=d}};
JSMatrix.Vector.prototype.sub=function(a){if(!this.isSameSizeAs(a))return null;for(var b=new JSMatrix.Vector,c=0;c<this.nElements;c++)b[c]=this[c]-a[c];b.nElements=this.nElements;return b};JSMatrix.Vector.prototype.isub=function(a){if(this.isSameSizeAs(a))for(var b=0;b<this.nElements;b++)this[b]-=a[b]};JSMatrix.Vector.prototype.beDifferenceOf=function(a,b){if(a.isSameSizeAs(b)){var c,d=a.nElements;for(c=0;c<d;c++)this[c]=a[c]-b[c];for(c=d;c<this.nElements;c++)delete this[c];this.nElements=d}};
JSMatrix.Vector.prototype.dot=function(a,b){b=b||-1;if(0>=b||b>this.nElements)b=this.nElements;if(b>a.nElements)return null;for(var c=0,d=0;d<b;d++)c+=this[d]*a[d];return c};JSMatrix.Vector.prototype.squaredNorm=function(){for(var a=0,b=this.nElements,c=0;c<b;c++)a+=this[c]*this[c];return a};JSMatrix.Vector.prototype.norm=function(){return Math.sqrt(this.dot(this))};JSMatrix.Vector.prototype.normalize=function(){var a=this.norm();0!=a&&this.imulf(1/a)};
JSMatrix.Vector.prototype.normalized=function(){var a=this.norm();if(0==a)return null;for(var b=new JSMatrix.Vector,c=1/a,a=0;a<this.nElements;a++)b[a]=this[a]*c;b.nElements=this.nElements;return b};JSMatrix.Vector.prototype.squaredEnergyNorm=function(a){return this.mulm(a).dot(this)};JSMatrix.Vector.prototype.energyNorm=function(a){return Math.sqrt(this.squaredEnergyNorm(a))};
JSMatrix.Vector.prototype.dyadic=function(a){for(var b=new JSMatrix.Matrix,c=0;c<this.nElements;c++){b[c]={};for(var d=0;d<a.nElements;d++)b[c][d]=this[c]*a[d]}b.nRows=this.nElements;b.nCols=a.nElements;return b};JSMatrix.Vector.prototype.otimes=JSMatrix.Vector.prototype.dyadic;JSMatrix.Vector.prototype.outer=JSMatrix.Vector.prototype.dyadic;JSMatrix.Vector.prototype.tensor=JSMatrix.Vector.prototype.dyadic;
JSMatrix.Vector.prototype.cross=function(a){return 3!=this.nElements||3!=a.nElements?null:JSMatrix.Vector.create([this[1]*a[2]-this[2]*a[1],this[2]*a[0]-this[0]*a[2],this[0]*a[1]-this[1]*a[0]])};JSMatrix.Vector.prototype.beCrossProductOf=function(a,b){if(3==a.nElements&&3==b.nElements){this[0]=a[1]*b[2]-a[2]*b[1];this[1]=a[2]*b[0]-a[0]*b[2];this[2]=a[0]*b[1]-a[1]*b[0];for(var c=3;c<this.nElements;c++)delete this[c];this.nElements=3}};JSMatrix.Vector.prototype.negated=function(){return this.mulf(-1)};
JSMatrix.Vector.prototype.neg=JSMatrix.Vector.prototype.negated;JSMatrix.Vector.prototype.negate=function(){for(var a=0;a<this.nElements;a++)this[a]*=-1};JSMatrix.Vector.prototype.ineg=JSMatrix.Vector.prototype.negate;JSMatrix.Vector.prototype.beNegativeOf=function(a){var b,c=a.nElements;for(b=0;b<c;b++)this[b]=-a[b];for(b=c;b<this.nElements;b++)delete this[b];this.nElements=c};
JSMatrix.Vector.prototype.mulf=function(a){for(var b=new JSMatrix.Vector,c=0;c<this.nElements;c++)b[c]=a*this[c];b.nElements=this.nElements;return b};JSMatrix.Vector.prototype.imulf=function(a){for(var b=0;b<this.nElements;b++)this[b]*=a};JSMatrix.Vector.prototype.mulm=function(a){if(!this.canMultiplyMat(a))return null;for(var b=new JSMatrix.Vector,c,d=a.nCols,e=this.nElements,f=0;f<d;f++){for(var g=c=0;g<e;g++)c+=this[g]*a[g][f];b[f]=c}b.nElements=d;return b};
JSMatrix.Vector.prototype.mul=function(a){return a instanceof JSMatrix.Matrix?this.mulm(a):"number"==(typeof a).toLowerCase()?this.mulf(a):null};JSMatrix.Vector.prototype.x=JSMatrix.Vector.prototype.mul;JSMatrix.Vector.prototype.beProductOf=function(a,b){if(a.canMultiplyVec(b)){var c=a.nRows,d=a.nCols,e,f,g;for(f=0;f<c;f++){for(g=e=0;g<d;g++)e+=a[f][g]*b[g];this[f]=e}for(f=c;f<this.nElements;f++)delete this[f];this.nElements=c}};
JSMatrix.Vector.prototype.beTProductOf=function(a,b){if(a.canMultiplyMat(b)){var c=b.nRows,d=b.nCols,e,f,g;for(g=0;g<d;g++){for(f=e=0;f<c;f++)e+=a[f]*b[f][g];this[g]=e}for(g=d;g<this.nElements;g++)delete this[g];this.nElements=d}};JSMatrix.Vector.prototype.getSubVector=function(a){var b=void 0==a.nElements?a.length:a.nElements;if(b>this.nElements)return null;var c,d,e=new JSMatrix.Vector;for(c=0;c<b;c++){d=a[c];if(0>d||d>=this.nElements)return null;e[c]=this[a[c]]}e.nElements=b;return e};
JSMatrix.Vector.prototype.getsv=JSMatrix.Vector.prototype.getSubVector;JSMatrix.Vector.prototype.beSubVectorOf=function(a,b){var c=void 0==b.nElements?b.length:b.nElements;if(!(c>a.nElements)){var d;for(d=0;d<c;d++)if(0>b[d]||b[d]>=a.nElements)return;for(d=0;d<c;d++)this[d]=a[b[d]];for(d=c;d<this.nElements;d++)delete this[d];this.nElements=c}};
JSMatrix.Vector.prototype.setSubVector=function(a,b){var c=void 0==a.nElements?a.length:a.nElements;if(b.nElements==c&&!(c>this.nElements)){var d;for(d=0;d<c;d++)if(0>a[d]||a[d]>=this.nElements)return;for(d=0;d<c;d++)this[a[d]]=b[d]}};JSMatrix.Vector.prototype.setsv=JSMatrix.Vector.prototype.setSubVector;
JSMatrix.Vector.prototype.incrSubVector=function(a,b){var c=void 0==a.nElements?a.length:a.nElements;if(b.nElements==c&&!(c>this.nElements)){var d;for(d=0;d<c;d++)if(0>a[d]||a[d]>=this.nElements)return;for(d=0;d<c;d++)this[a[d]]+=b[d]}};JSMatrix.Vector.prototype.incrsv=JSMatrix.Vector.prototype.incrSubVector;
JSMatrix.Vector.prototype.decrSubVector=function(a,b){var c=void 0==a.nElements?a.length:a.nElements;if(b.nElements==c&&!(c>this.nElements)){var d;for(d=0;d<c;d++)if(0>a[d]||a[d]>=this.nElements)return;for(d=0;d<c;d++)this[a[d]]-=b[d]}};JSMatrix.Vector.prototype.decrsv=JSMatrix.Vector.prototype.decrSubVector;
JSMatrix.Vector.prototype.assemble=function(a,b){var c=void 0==b.nElements?b.length:b.nElements;if(this.nElements==c&&!(c>a.nElements)){var d;for(d=0;d<c;d++)if(0>b[d]||b[d]>=a.nElements)return;for(d=0;d<c;d++)a[b[d]]+=this[d]}};JSMatrix.Vector.prototype.beRowOf=function(a,b){var c,d=a.nCols;for(c=0;c<d;c++)this[c]=a[b][c];for(c=d;c<this.nElements;c++)delete this[c];this.nElements=d};
JSMatrix.Vector.prototype.beColOf=function(a,b){var c,d=a.nRows;for(c=0;c<d;c++)this[c]=a[c][b];for(c=d;c<this.nElements;c++)delete this[c];this.nElements=d};JSMatrix.Vector.prototype.beColumnOf=JSMatrix.Vector.prototype.beColOf;JSMatrix.Vector.prototype.copied=function(){var a=new JSMatrix.Vector,b,c=this.nElements;for(b=0;b<c;b++)a[b]=this[b];a.nElements=c;return a};JSMatrix.Vector.prototype.copy=JSMatrix.Vector.prototype.copied;
JSMatrix.Vector.prototype.beCopyOf=function(a){var b=a.nElements,c;for(c=0;c<b;c++)this[c]=a[c];for(c=b;c<this.nElements;c++)delete this[c];this.nElements=b};JSMatrix.Vector.prototype.toString=function(){var a=this.nElements,b,c;if(0==a)return"Vector([])\n";var d="Vector([ ";for(b=0;b<a-1;b++)c=this[b],d+=c.toExponential(3)+", ";c=this[a-1];return d+=c.toExponential(3)+" ])\n"};
JSMatrix.Vector.prototype.swapElements=function(a,b){if(a!=b&&!(0>a||0>b||a>=this.nElements||b>=this.nElements)){var c=this[a];this[a]=this[b];this[b]=c}};JSMatrix.Vector.prototype.appendElements=function(a){if(a instanceof JSMatrix.Vector){var b=a.nElements,c;for(c=0;c<b;c++)this[this.nElements]=a[c],this.nElements++}else if(a instanceof Array)for(b=a.length,c=0;c<b;c++)this.appendElements(a[c]);else"number"==(typeof a).toLowerCase()&&(this[this.nElements]=a,this.nElements++)};
JSMatrix.Vector.prototype.permuteElements=function(a,b){var c;void 0==a.nElements?(c=a.length,a=a.slice()):(c=a.nElements,a=a.toArray());if(c==this.nElements){for(var d=0;d<c;d++)if(0>d||d>=this.nElements)return;var e;if(b)for(d=0;d<c;d++)for(e=a[d];e!=d;)this.swapElements(d,e),a[d]=a[e],a[e]=e,e=a[d];else for(d=c-1;0<d;d--)e=a[d],this.swapElements(d,e),a[a.indexOf(d)]=e}};
JSMatrix.Vector.prototype.elementsPermutation=function(a,b){var c=void 0==a.nElements?a.length:a.nElements;if(c!=this.nElements)return null;for(var d=0;d<c;d++)if(0>d||d>=this.nElements)return null;c=new JSMatrix.Vector;if(b)for(d=0;d<this.nElements;d++)c[a[d]]=this[d];else for(d=0;d<this.nElements;d++)c[d]=this[a[d]];c.nElements=this.nElements;return c};
JSMatrix.Vector.prototype.resize=function(a){if(a!=this.nElements)if(a>this.nElements){for(var b=this.nElements;b<a;b++)this[b]=0;this.nElements=a}else if(a<this.nElements){for(b=a;b<this.nElements;b++)delete this[b];this.nElements=a}};JSMatrix.Vector.prototype.resized=function(a){var b,c=new JSMatrix.Vector;if(a<=this.nElements)for(b=0;b<a;b++)c[b]=this[b];else{for(b=0;b<this.nElements;b++)c[b]=this[b];for(b=this.nElements;b<a;b++)c[b]=0}c.nElements=a;return c};
JSMatrix.Vector.prototype.toDiagonalMatrix=function(){for(var a=JSMatrix.Matrix.Zeros(this.nElements,this.nElements),b=0;b<this.nElements;b++)a[b][b]=this[b];return a};JSMatrix.Vector.prototype.beDiagonalFrom=function(a){if(a.isSquare()){var b,c=a.nRows;for(b=0;b<c;b++)this[b]=a[b][b];for(b=c;c<this.nElements;b++)delete this[b];this.nElements=c}};JSMatrix.Vector.prototype.diag=function(a){if(void 0==a)return this.toDiagonalMatrix();this.beDiagonalFrom(a)};
JSMatrix.Vector.prototype.beSolutionOf=function(a,b,c,d,e){a=void 0==d||d?a.copy():a;this.beCopyOf(b);a.linSolve(this,c,!1,e)};JSMatrix.Vector.create=function(a){a=a||[];for(var b=a.length,c=new JSMatrix.Vector,d=0;d<b;d++)c[d]=a[d];c.nElements=b;return c};JSMatrix.Vector.UnitX=function(){return JSMatrix.Vector.create([1,0,0])};JSMatrix.Vector.UnitY=function(){return JSMatrix.Vector.create([0,1,0])};JSMatrix.Vector.UnitZ=function(){return JSMatrix.Vector.create([0,0,1])};
JSMatrix.Vector.Zeros=function(a){return new JSMatrix.Vector(a||0)};JSMatrix.Vector.Ones=function(a){a=a||0;var b,c=new JSMatrix.Vector;for(b=0;b<a;b++)c[b]=1;c.nElements=a;return c};JSMatrix.Matrix.prototype.empty=function(){this.resize(0,0)};JSMatrix.Matrix.prototype.isEmpty=function(){return 0==this.nRows&&0==this.nCols};JSMatrix.Matrix.prototype.zero=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<this.nCols;b++)this[a][b]=0};
JSMatrix.Matrix.prototype.beFullOfOnes=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<this.nCols;b++)this[a][b]=1};JSMatrix.Matrix.prototype.one=JSMatrix.Matrix.prototype.beFullOfOnes;JSMatrix.Matrix.prototype.beUnitMatrix=function(a){a=void 0===a?0:a;if(0>=a){if(this.isSquare())for(this.zero(),a=0;a<this.nRows;a++)this[a][a]=1}else{var b;this.resize(a,a);for(b=0;b<a;b++)this[b][b]=1}};JSMatrix.Matrix.prototype.size=function(){return{nRows:this.nRows,nCols:this.nCols}};
JSMatrix.Matrix.prototype.trace=function(){if(!this.isSquare())return null;for(var a=0,b=0;b<this.nRows;b++)a+=this[b][b];return a};JSMatrix.Matrix.prototype.diagSum=JSMatrix.Matrix.prototype.trace;JSMatrix.Matrix.prototype.diagProduct=function(){if(!this.isSquare())return null;for(var a=1,b=0;b<this.nRows;b++)if(a*=this[b][b],0==a)return 0;return a};JSMatrix.Matrix.prototype.dprod=JSMatrix.Matrix.prototype.diagProduct;
JSMatrix.Matrix.prototype.get=function(a,b){return 0>a||0>b||a>=this.nRows||b>=this.nCols?null:this[a][b]};JSMatrix.Matrix.prototype.set=function(a,b,c){0>a||0>b||a>=this.nRows||b>=this.nCols||(this[a][b]=c)};JSMatrix.Matrix.prototype.incr=function(a,b,c){0>a||0>b||a>=this.nRows||b>=this.nCols||c&&(this[a][b]+=c)};
JSMatrix.Matrix.prototype.fromArray=function(a){var b,c,d=a.length,e=a[0].length;for(b=0;b<d;b++){b>=this.nRows&&(this[b]={});for(c=0;c<e;c++)this[b][c]=a[b][c];for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=d;b<this.nRows;b++)delete this[b];this.nRows=d;this.nCols=e};JSMatrix.Matrix.prototype.toArray=function(){var a,b,c=[];for(a=0;a<this.nRows;a++)for(c[a]=[],b=0;b<this.nCols;b++)c[a][b]=this[a][b];return c};
JSMatrix.Matrix.prototype.add=function(a){if(!this.isSameSizeAs(a))return null;var b,c,d=this.nRows,e=this.nCols,f=new JSMatrix.Matrix;for(b=0;b<d;b++)for(f[b]={},c=0;c<e;c++)f[b][c]=this[b][c]+a[b][c];f.nRows=d;f.nCols=e;return f};JSMatrix.Matrix.prototype.iadd=function(a){if(this.isSameSizeAs(a))for(var b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)this[b][c]+=a[b][c]};
JSMatrix.Matrix.prototype.beSumOf=function(a,b){if(a.isSameSizeAs(b)){var c,d,e=a.nRows,f=a.nCols;for(c=0;c<e;c++){c>=this.nRows&&(this[c]={});for(d=0;d<f;d++)this[c][d]=a[c][d]+b[c][d];for(d=f;d<this.nCols;d++)delete this[c][d]}for(c=e;c<this.nRows;c++)delete this[c];this.nRows=e;this.nCols=f}};
JSMatrix.Matrix.prototype.sub=function(a){if(!this.isSameSizeAs(a))return null;var b,c,d=this.nRows,e=this.nCols,f=new JSMatrix.Matrix;for(b=0;b<d;b++)for(f[b]={},c=0;c<e;c++)f[b][c]=this[b][c]-a[b][c];f.nRows=d;f.nCols=e;return f};JSMatrix.Matrix.prototype.isub=function(a){if(this.isSameSizeAs(a))for(var b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)this[b][c]-=a[b][c]};
JSMatrix.Matrix.prototype.beDifferenceOf=function(a,b){if(a.isSameSizeAs(b)){var c,d,e=a.nRows,f=a.nCols;for(c=0;c<e;c++){c>=this.nRows&&(this[c]={});for(d=0;d<f;d++)this[c][d]=a[c][d]-b[c][d];for(d=f;d<this.nCols;d++)delete this[c][d]}for(c=e;c<this.nRows;c++)delete this[c];this.nRows=e;this.nCols=f}};JSMatrix.Matrix.prototype.negated=function(){return this.mulf(-1)};JSMatrix.Matrix.prototype.neg=JSMatrix.Matrix.prototype.negated;
JSMatrix.Matrix.prototype.negate=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<this.nCols;b++)this[a][b]*=-1};JSMatrix.Matrix.prototype.ineg=JSMatrix.Matrix.prototype.negate;JSMatrix.Matrix.prototype.beNegativeOf=function(a){var b,c,d=a.nRows,e=a.nCols;for(b=0;b<d;b++){b>=this.nRows&&(this[b]={});for(c=0;c<e;c++)this[b][c]=-a[b][c];for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=d;b<this.nRows;b++)delete this[b];this.nRows=d;this.nCols=e};
JSMatrix.Matrix.prototype.getRow=function(a){for(var b=new JSMatrix.Vector,c=0;c<this.nCols;c++)b[c]=this[a][c];b.nElements=this.nCols;return b};JSMatrix.Matrix.prototype.getCol=function(a){for(var b=new JSMatrix.Vector,c=0;c<this.nRows;c++)b[c]=this[c][a];b.nElements=this.nRows;return b};JSMatrix.Matrix.prototype.setRow=function(a,b){if(!(0>a||a>=this.nRows)&&this.nCols==b.nElements)for(var c=0;c<this.nCols;c++)this[a][c]=b[c]};
JSMatrix.Matrix.prototype.setCol=function(a,b){if(!(0>a||a>=this.nCols)&&this.nRows==b.nElements)for(var c=0;c<this.nRows;c++)this[c][a]=b[c]};JSMatrix.Matrix.prototype.incrRow=function(a,b){if(!(0>a||a>=this.nRows)&&this.nCols==b.nElements)for(var c=0;c<this.nCols;c++)this[a][c]+=b[c]};JSMatrix.Matrix.prototype.incrCol=function(a,b){if(!(0>a||a>=this.nCols)&&this.nRows==b.nElements)for(var c=0;c<this.nRows;c++)this[c][a]+=b[c]};
JSMatrix.Matrix.prototype.decrRow=function(a,b){if(!(0>a||a>=this.nRows)&&this.nCols==b.nElements)for(var c=0;c<this.nCols;c++)this[a][c]-=b[c]};JSMatrix.Matrix.prototype.decrCol=function(a,b){if(!(0>a||a>=this.nCols)&&this.nRows==b.nElements)for(var c=0;c<this.nRows;c++)this[c][a]-=b[c]};JSMatrix.Matrix.prototype.swapRows=function(a,b){if(a!=b&&!(0>a||a>=this.nRows||0>b||b>=this.nRows)){var c=this[a];this[a]=this[b];this[b]=c}};
JSMatrix.Matrix.prototype.swapCols=function(a,b){if(a!=b&&!(0>a||a>=this.nCols||0>b||b>=this.nCols))for(var c,d=0;d<this.nRows;d++)c=this[d][a],this[d][a]=this[d][b],this[d][b]=c};
JSMatrix.Matrix.prototype.permuteRows=function(a,b){var c,d;void 0==a.nElements?(c=a.length,a=a.slice()):(c=a.nElements,a=a.toArray());if(c==this.nRows){for(d=0;d<c;d++)if(0>d||d>=this.nRows)return;var e;if(b)for(d=0;d<c;d++)for(e=a[d];e!=d;)this.swapRows(d,e),a[d]=a[e],a[e]=e,e=a[d];else for(d=c-1;0<d;d--)e=a[d],this.swapRows(d,e),a[a.indexOf(d)]=e}};
JSMatrix.Matrix.prototype.rowPermutation=function(a,b){var c,d;d=void 0==a.nElements?a.length:a.nElements;if(d!=this.nRows)return null;for(c=0;c<d;c++)if(0>c||c>=this.nRows)return null;var e=new JSMatrix.Matrix;if(b){for(c=0;c<this.nRows;c++)e[c]={};for(c=0;c<this.nRows;c++)for(d=0;d<this.nCols;d++)e[a[c]][d]=this[c][d]}else for(c=0;c<this.nRows;c++)for(e[c]={},d=0;d<this.nCols;d++)e[c][d]=this[a[c]][d];e.nRows=this.nRows;e.nCols=this.nCols;return e};
JSMatrix.Matrix.prototype.mulf=function(a){var b=new JSMatrix.Matrix,c,d,e=this.nRows,f=this.nCols;for(c=0;c<e;c++)for(b[c]={},d=0;d<f;d++)b[c][d]=a*this[c][d];b.nRows=e;b.nCols=f;return b};JSMatrix.Matrix.prototype.imulf=function(a){for(var b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)this[b][c]*=a};
JSMatrix.Matrix.prototype.mulv=function(a){if(!this.canMultiplyVec(a))return null;for(var b=new JSMatrix.Vector,c,d=0;d<this.nRows;d++){for(var e=c=0;e<this.nCols;e++)c+=this[d][e]*a[e];b[d]=c}b.nElements=this.nRows;return b};JSMatrix.Matrix.prototype.mulm=function(a){if(!this.canMultiplyMat(a))return null;var b=new JSMatrix.Matrix,c,d,e,f;for(c=0;c<this.nRows;c++)for(b[c]={},d=0;d<a.nCols;d++){for(e=f=0;e<this.nCols;e++)f+=this[c][e]*a[e][d];b[c][d]=f}b.nRows=this.nRows;b.nCols=a.nCols;return b};
JSMatrix.Matrix.prototype.mul=function(a){return a instanceof JSMatrix.Vector?this.mulv(a):a instanceof JSMatrix.Matrix?this.mulm(a):"number"==(typeof a).toLowerCase()?this.mulf(a):null};JSMatrix.Matrix.prototype.x=JSMatrix.Matrix.prototype.mul;
JSMatrix.Matrix.prototype.beDyadicProductOf=function(a,b){var c,d,e=a.nElements,f=b.nElements;for(c=0;c<e;c++){c>=this.nRows&&(this[c]={});for(d=0;d<f;d++)this[c][d]=a[c]*b[d];for(d=f;d<this.nCols;d++)delete this[c][d]}for(c=e;c<this.nRows;c++)delete this[c];this.nRows=e;this.nCols=f};
JSMatrix.Matrix.prototype.beProductOf=function(a,b){if(a.canMultiplyMat(b)){var c,d,e,f,g=a.nRows,h=b.nCols;for(c=0;c<g;c++){c>=this.nRows&&(this[c]={});for(d=0;d<h;d++){for(e=f=0;e<a.nCols;e++)f+=a[c][e]*b[e][d];this[c][d]=f}for(d=h;d<this.nCols;d++)delete this[c][d]}for(c=g;c<this.nRows;c++)delete this[c];this.nRows=g;this.nCols=h}};
JSMatrix.Matrix.prototype.beTProductOf=function(a,b){var c,d,e,f,g=a.nCols,h=b.nCols;if(a.nRows==b.nRows){for(c=0;c<g;c++){c>=this.nRows&&(this[c]={});for(d=0;d<h;d++){for(e=f=0;e<a.nRows;e++)f+=a[e][c]*b[e][d];this[c][d]=f}for(d=h;d<this.nCols;d++)delete this[c][d]}for(c=g;c<this.nRows;c++)delete this[c];this.nRows=g;this.nCols=h}};
JSMatrix.Matrix.prototype.beProductTOf=function(a,b){var c,d,e,f,g=a.nRows,h=b.nRows;if(a.nCols==b.nCols){for(c=0;c<g;c++){c>=this.nRows&&(this[c]={});for(d=0;d<h;d++){for(e=f=0;e<a.nCols;e++)f+=a[c][e]*b[d][e];this[c][d]=f}for(d=h;d<this.nCols;d++)delete this[c][d]}for(c=g;c<this.nRows;c++)delete this[c];this.nRows=g;this.nCols=h}};
JSMatrix.Matrix.prototype.beTProductTOf=function(a,b){var c,d,e,f,g=a.nRows,h=b.nCols;if(a.nCols==b.nCols){for(c=0;c<g;c++){c>=this.nRows&&(this[c]={});for(d=0;d<h;d++){for(e=f=0;e<a.nRows;e++)f+=a[e][c]*b[d][e];this[c][d]=f}for(d=h;d<this.nCols;d++)delete this[c][d]}for(c=g;c<this.nRows;c++)delete this[c];this.nRows=g;this.nCols=h}};
JSMatrix.Matrix.prototype.transposed=function(){for(var a=new JSMatrix.Matrix(this.nCols,this.nRows),b=0;b<this.nCols;b++){a[b]={};for(var c=0;c<this.nRows;c++)a[b][c]=this[c][b]}return a};JSMatrix.Matrix.prototype.T=JSMatrix.Matrix.prototype.transposed;
JSMatrix.Matrix.prototype.transpose=function(){var a,b,c,d=this.nRows,e=this.nCols,f=Math.min(d,e);for(b=0;b<f;b++)for(c=b+1;c<f;c++)a=this[b][c],this[b][c]=this[c][b],this[c][b]=a;if(d>e)for(b=e;b<d;b++){for(c=0;c<e;c++)this[c][b]=this[b][c];delete this[b]}else if(d<e)for(c=d;c<e;c++)for(this[c]={},b=0;b<d;b++)this[c][b]=this[b][c],delete this[b][c];this.nRows=e;this.nCols=d};
JSMatrix.Matrix.prototype.beTranspositionOf=function(a){var b,c,d=a.nCols,e=a.nRows;for(b=0;b<d;b++){b>=this.nRows&&(this[b]={});for(c=0;c<e;c++)this[b][c]=a[c][b];for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=d;b<this.nRows;b++)delete this[b];this.nRows=d;this.nCols=e};JSMatrix.Matrix.prototype.symmetrize=function(){if(this.isSquare()){var a,b,c,d=this.nRows;for(a=0;a<d-1;a++)for(b=a+1;b<d;b++)c=0.5*(this[a][b]+this[b][a]),this[a][b]=c,this[b][a]=c}};
JSMatrix.Matrix.prototype.symmetrized=function(){if(!this.isSquare())return null;var a=new JSMatrix.Matrix,b,c,d,e=this.nRows;for(b=0;b<e;b++)a[b]={};for(b=0;b<e;b++)a[b][b]=this[b][b];for(b=0;b<e-1;b++)for(c=b+1;c<e;c++)d=0.5*(this[b][c]+this[c][b]),a[b][c]=d,a[c][b]=d;a.nRows=e;a.nCols=e;return a};JSMatrix.Matrix.prototype.giveSymmetricPart=JSMatrix.Matrix.prototype.symmetrized;
JSMatrix.Matrix.prototype.beSymmetricPartOf=function(a){if(a.isSquare()){var b,c,d,e=a.nRows;for(b=0;b<e;b++)b>=this.nRows&&(this[b]={}),this[b][b]=a[b][b];for(b=0;b<e-1;b++){for(c=b+1;c<e;c++)d=0.5*(a[b][c]+a[c][b]),this[b][c]=d,this[c][b]=d;for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=e;b<this.nRows;b++)delete this[b];this.nCols=this.nRows=e}};
JSMatrix.Matrix.prototype.antiSymmetrize=function(){if(this.isSquare()){var a,b,c,d=this.nRows;for(a=0;a<d;a++)this[a][a]=0;for(a=0;a<d;a++)for(b=a+1;b<d;b++)c=0.5*(this[a][b]+this[b][a]),this[a][b]-=c,this[b][a]-=c}};
JSMatrix.Matrix.prototype.antiSymmetrized=function(){if(!this.isSquare())return null;var a=new JSMatrix.Matrix,b,c,d,e=this.nRows;for(b=0;b<e;b++)a[b]={};for(b=0;b<e;b++)a[b][b]=0;for(b=0;b<e-1;b++)for(c=b+1;c<e;c++)d=0.5*(this[b][c]+this[c][b]),a[b][c]=this[b][c]-d,a[c][b]=this[c][b]-d;a.nRows=e;a.nCols=e;return a};JSMatrix.Matrix.prototype.giveAntiSymmetricPart=JSMatrix.Matrix.prototype.antiSymmetrized;
JSMatrix.Matrix.prototype.beAntiSymmetricPartOf=function(a){if(a.isSquare()){var b,c,d,e=a.nRows;for(b=0;b<e;b++)b>=this.nRows&&(this[b]={}),this[b][b]=0;for(b=0;b<e;b++){for(c=b+1;c<e;c++)d=0.5*(a[b][c]+a[c][b]),this[b][c]=a[b][c]-d,this[c][b]=a[c][b]-d;for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=e;b<this.nRows;b++)delete this[b];this.nCols=this.nRows=e}};
JSMatrix.Matrix.prototype.getSubMatrix=function(a,b){var c=void 0==a.nElements?a.length:a.nElements,d=void 0==b.nElements?b.length:b.nElements;if(c>this.nRows||d>this.nCols)return null;var e,f,g,h,k=new JSMatrix.Matrix;for(e=0;e<c;e++)for(k[e]={},f=0;f<d;f++){g=a[e];h=b[f];if(0>g||g>=this.nRows||0>h||h>=this.nCols)return null;k[e][f]=this[g][h]}k.nRows=c;k.nCols=d;return k};JSMatrix.Matrix.prototype.getsm=JSMatrix.Matrix.prototype.getSubMatrix;
JSMatrix.Matrix.prototype.beSubMatrixOf=function(a,b,c){var d=void 0==b.nElements?b.length:b.nElements,e=void 0==c.nElements?c.length:c.nElements;if(!(d>a.nRows||e>a.nCols)){var f,g;for(f=0;f<d;f++)if(0>b[f]||b[f]>=a.nRows)return;for(g=0;g<e;g++)if(0>c[g]||c[g]>=a.nCols)return;for(f=0;f<d;f++){this[f]={};for(g=0;g<e;g++)this[f][g]=a[b[f]][c[g]];for(g=e;g<this.nCols;g++)delete this[f][g]}for(f=d;f<this.nRows;f++)delete this[f];this.nRows=d;this.nCols=e}};
JSMatrix.Matrix.prototype.setSubMatrix=function(a,b,c){var d=void 0==a.nElements?a.length:a.nElements,e=void 0==b.nElements?b.length:b.nElements,f=c.nCols;if(c.nRows==d&&f==e&&!(d>this.nRows||e>this.nCols)){for(var g,f=0;f<d;f++)if(0>a[f]||a[f]>=this.nRows)return;for(g=0;g<e;g++)if(0>b[g]||b[g]>=this.nCols)return;for(f=0;f<d;f++)for(g=0;g<e;g++)this[a[f]][b[g]]=c[f][g]}};JSMatrix.Matrix.prototype.setsm=JSMatrix.Matrix.prototype.setSubMatrix;
JSMatrix.Matrix.prototype.incrSubMatrix=function(a,b,c){var d=void 0==a.nElements?a.length:a.nElements,e=void 0==b.nElements?b.length:b.nElements,f=c.nCols;if(c.nRows==d&&f==e&&!(d>this.nRows||e>this.nCols)){for(var g,f=0;f<d;f++)if(0>a[f]||a[f]>=this.nRows)return;for(g=0;g<e;g++)if(0>b[g]||b[g]>=this.nCols)return;for(f=0;f<d;f++)for(g=0;g<e;g++)this[a[f]][b[g]]+=c[f][g]}};JSMatrix.Matrix.prototype.incrsm=JSMatrix.Matrix.prototype.incrSubMatrix;
JSMatrix.Matrix.prototype.decrSubMatrix=function(a,b,c){var d=void 0==a.nElements?a.length:a.nElements,e=void 0==b.nElements?b.length:b.nElements,f=c.nCols;if(c.nRows==d&&f==e&&!(d>this.nRows||e>this.nCols)){for(var g,f=0;f<d;f++)if(0>a[f]||a[f]>=this.nRows)return;for(g=0;g<e;g++)if(0>b[g]||b[g]>=this.nCols)return;for(f=0;f<d;f++)for(g=0;g<e;g++)this[a[f]][b[g]]-=c[f][g]}};JSMatrix.Matrix.prototype.decrsm=JSMatrix.Matrix.prototype.decrSubMatrix;
JSMatrix.Matrix.prototype.assemble=function(a,b,c){var d=void 0==b.nElements?b.length:b.nElements,e=void 0==c.nElements?c.length:c.nElements,f=this.nCols;if(this.nRows==d&&f==e&&!(d>a.nRows||e>a.nCols)){for(var g,f=0;f<d;f++)if(0>b[f]||b[f]>=a.nRows)return;for(g=0;g<e;g++)if(0>c[g]||c[g]>=a.nCols)return;for(f=0;f<d;f++)for(g=0;g<e;g++)a[b[f]][c[g]]+=this[f][g]}};
JSMatrix.Matrix.prototype.copied=function(){for(var a=new JSMatrix.Matrix,b=0;b<this.nRows;b++){a[b]={};for(var c=0;c<this.nCols;c++)a[b][c]=this[b][c]}a.nRows=this.nRows;a.nCols=this.nCols;return a};JSMatrix.Matrix.prototype.copy=JSMatrix.Matrix.prototype.copied;
JSMatrix.Matrix.prototype.beCopyOf=function(a){var b,c,d=a.nRows,e=a.nCols;for(b=0;b<d;b++){b>=this.nRows&&(this[b]={});for(c=0;c<e;c++)this[b][c]=a[b][c];for(c=e;c<this.nCols;c++)delete this[b][c]}for(b=d;b<this.nRows;b++)delete this[b];this.nRows=d;this.nCols=e};JSMatrix.Matrix.prototype.diagonalToVector=function(){if(!this.isSquare())return null;for(var a=new JSMatrix.Vector,b=0;b<this.nRows;b++)a[b]=this[b][b];a.nElements=this.nRows;return a};JSMatrix.Matrix.prototype.diag=JSMatrix.Matrix.prototype.diagonalToVector;
JSMatrix.Matrix.prototype.toString=function(){var a=this.nRows,b=this.nCols,c,d,e,f="Matrix([[ ";if(0==a)return f+"]])";if(0==b){for(c=0;c<a-1;c++)f+=" [], ";return f+"])"}for(c=0;c<a-1;c++){for(d=0;d<b-1;d++)e=this[c][d],f+=e.toExponential(3)+", ";e=this[c][b-1];f+=e.toExponential(3)+" ], [ "}for(d=0;d<b-1;d++)e=this[a-1][d],f+=e.toExponential(3)+", ";e=this[a-1][b-1];return f+=e.toExponential(3)+" ]])"};
JSMatrix.Matrix.prototype.resize=function(a,b){if(this.nRows<a){for(var c=this.nRows;c<a;c++){this[c]={};for(var d=0;d<this.nCols;d++)this[c][d]=0}this.nRows=a}if(this.nRows>a){for(c=a;c<this.nRows;c++)delete this[c];this.nRows=a}if(this.nCols<b){for(c=0;c<this.nRows;c++)for(d=this.nCols;d<b;d++)this[c][d]=0;this.nCols=b}if(this.nCols>b){for(c=0;c<this.nRows;c++)for(d=b;d<this.nCols;d++)delete this[c][d];this.nCols=b}};
JSMatrix.Matrix.prototype.resized=function(a,b){var c,d,e=new JSMatrix.Matrix;for(c=0;c<a;c++)e[c]={};if(a<=this.nRows)if(b<=this.nCols)for(c=0;c<a;c++)for(d=0;d<b;d++)e[c][d]=this[c][d];else for(c=0;c<a;c++){for(d=0;d<this.nCols;d++)e[c][d]=this[c][d];for(d=this.nCols;d<b;d++)e[c][d]=0}else{if(b<=this.nCols)for(c=0;c<this.nRows;c++)for(d=0;d<b;d++)e[c][d]=this[c][d];else for(c=0;c<this.nRows;c++){for(d=0;d<this.nRows;d++)e[c][d]=this[c][d];for(d=this.nCols;d<b;d++)e[c][d]=0}for(c=this.nRows;c<a;c++)for(d=
0;d<b;d++)e[c][d]=0}e.nRows=a;e.nCols=b;return e};JSMatrix.Matrix.prototype.appendRows=function(a){if(a instanceof JSMatrix.Vector){if(a.nElements==this.nCols){this[this.nRows]={};for(var b=0;b<this.nCols;b++)this[this.nRows][b]=a[b];this.nRows++}}else if(a instanceof JSMatrix.Matrix){if(a.nCols==this.nCols)for(var c=0;c<a.nRows;c++){this[this.nRows]={};for(b=0;b<this.nCols;b++)this[this.nRows][b]=a[c][b];this.nRows++}}else if(a instanceof Array)for(b=0;b<a.length;b++)this.appendRows(a[b])};
JSMatrix.Matrix.prototype.appendCols=function(a){if(a instanceof JSMatrix.Vector){if(a.nElements==this.nRows){for(var b=0;b<this.nRows;b++)this[b][this.nCols]=a[b];this.nCols++}}else if(a instanceof JSMatrix.Matrix){if(a.nRows==this.nRows){for(b=0;b<this.nRows;b++)for(var c=0;c<a.nCols;c++)this[b][this.nCols+c]=a[b][c];this.nCols+=a.nCols}}else if(a instanceof Array)for(b=0;b<a.length;b++)this.appendCols(a[b])};
JSMatrix.Matrix.prototype.max=function(){for(var a=-1E20,b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)a=Math.max(a,this[b][c]);return a};JSMatrix.Matrix.prototype.min=function(){for(var a=1E20,b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)a=Math.min(a,this[b][c]);return a};JSMatrix.Matrix.prototype.abs=function(){for(var a=new JSMatrix.Matrix(this.nRows,this.nCols),b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)a[b][c]=Math.abs(this[b][c]);return a};
JSMatrix.Matrix.prototype.isEqualTo=function(a){if(!this.isSameSizeAs(a))return!1;for(var b=0;b<this.nRows;b++)for(var c=0;c<this.nCols;c++)if(Math.abs(this[b][c]-a[b][c])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.isSameSizeAs=function(a){return this.nRows==a.nRows&&this.nCols==a.nCols};JSMatrix.Matrix.prototype.canMultiplyMat=function(a){return this.nCols==a.nRows};JSMatrix.Matrix.prototype.canMultiplyVec=function(a){return this.nCols==a.nElements};
JSMatrix.Matrix.prototype.isSquare=function(){return this.nRows==this.nCols};JSMatrix.Matrix.prototype.isSymmetric=function(){if(!this.isSquare())return!1;for(var a=0;a<this.nRows;a++)for(var b=a+1;b<this.nCols;b++)if(Math.abs(this[a][b]-this[b][a])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.isAntiSymmetric=function(){if(!this.isSquare())return!1;for(var a=0;a<this.nRows;a++)for(var b=a;b<this.nCols;b++)if(Math.abs(this[a][b]+this[b][a])>JSMatrix.TOL)return!1;return!0};
JSMatrix.Matrix.prototype.isTranspositionOf=function(a){if(this.nRows!=a.nCols||this.nCols!=a.nRows)return!1;var b,c;for(b=0;b<this.nRows;b++)for(c=0;c<this.nCols;c++)if(Math.abs(this[b][c]-a[c][b])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.isLowerTriangular=function(){for(var a=0;a<this.nRows;a++)for(var b=a+1;b<this.nCols;b++)if(Math.abs(this[a][b])>JSMatrix.TOL)return!1;return!0};
JSMatrix.Matrix.prototype.isUpperTriangular=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<a;b++)if(Math.abs(this[a][b])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.isSingular=function(){var a=this.determinant();return isNaN(a)?!0:Math.abs(a)<JSMatrix.TOL};
JSMatrix.Matrix.prototype.isIdentity=function(){if(!this.isSquare())return!1;var a,b;for(a=0;a<this.nRows;a++)if(Math.abs(this[a][a]-1)>JSMatrix.TOL)return!1;for(a=1;a<this.nRows;a++)for(b=a+1;b<this.nCols;b++)if(Math.abs(this[a][b])>JSMatrix.TOL||Math.abs(this[b][a])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.isUnitMatrix=JSMatrix.Matrix.prototype.isIdentity;
JSMatrix.Matrix.prototype.isZero=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<this.nCols;b++)if(Math.abs(this[a][b])>JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.containsOnlyZeros=JSMatrix.Matrix.prototype.isZero;JSMatrix.Matrix.prototype.isOne=function(){for(var a=0;a<this.nRows;a++)for(var b=0;b<this.nCols;b++)if(Math.abs(this[a][b]-1)>2*JSMatrix.TOL)return!1;return!0};JSMatrix.Matrix.prototype.containsOnlyOnes=JSMatrix.Matrix.prototype.isOne;
JSMatrix.Matrix.prototype.isOrthogonal=function(){var a=new JSMatrix.Matrix;a.beProductTOf(this,this);return a.isIdentity()};JSMatrix.Matrix.prototype.isPositiveDefinite=function(){return null!=this.choleskyDecomposition()};JSMatrix.Matrix.prototype.isInvolutary=function(){var a=new JSMatrix.Matrix;a.beProductOf(this,this);return a.isIdentity()};
JSMatrix.Matrix.prototype.implicitPartialPivotPermutation=function(a){var b=this.nRows;a=void 0==a||a?this.copy():this;var c=[],d=JSMatrix.range(b),e,f,g,h,k;for(f=0;f<b;f++){for(g=e=0;g<b;g++)(h=Math.abs(a[f][g]))>e&&(e=h);if(0==e)return null;c[f]=1/e}for(g=0;g<b;g++){e=0;for(f=g;f<b;f++)h=c[f]*Math.abs(a[f][g]),h>e&&(e=h,k=f);g!=k&&(a.swapRows(g,k),c[k]=c[g],h=d[g],d[g]=k,d[k]=h)}return{mat:a,coeffs:d}};
JSMatrix.Matrix.prototype.forwardSubstitution=function(a,b){if(!this.isSquare()||!this.canMultiplyVec(a))return null;var c,d=this.nRows,e=void 0==b||b?a.copy():a,f,g;for(f=0;f<d;f++){c=e[f];for(g=0;g<f;g++)c-=this[f][g]*e[g];e[f]=c/this[f][f]}return e};JSMatrix.Matrix.prototype.backwardSubstitution=function(a,b){if(!this.isSquare()||!this.canMultiplyVec(a))return null;var c,d=this.nRows,e=void 0==b||b?a.copy():a,f,g;for(f=d-1;0<=f;f--){c=e[f];for(g=f+1;g<d;g++)c-=this[f][g]*e[g];e[f]=c/this[f][f]}return e};
JSMatrix.Matrix.prototype.gaussianElimination=function(a,b,c){if(!this.canMultiplyVec(a)||!this.isSquare())return null;b=b||"default";c=void 0==c?!0:c;var d=this.nRows,e,f;if("nopivot"==b||"default"==b){b=c?this.copy():this;var g=c?a.copy():a;for(e=0;e<d-1;e++)for(f=b[e][e],a=e+1;a<d;a++){for(c=e+1;c<d;c++)b[a][c]-=b[e][c]*b[a][e]/f;g[a]-=g[e]*b[a][e]/f}return b.backwardSubstitution(g,!1)}return"partpivot"==b?(b=this.implicitPartialPivotPermutation(c),g=c?a.copy():a,g.permuteElements(b.coeffs),b.mat.gaussianElimination(g,
"nopivot",!1)):this.gaussianElimination(a,"default",c)};
JSMatrix.Matrix.prototype.gaussJordanElimination=function(a,b,c){if(!this.isSquare)return null;var d=a instanceof JSMatrix.Vector?1:a instanceof Array?2:a instanceof JSMatrix.Matrix?3:4;if(1!=d&&2!=d&&3!=d)return null;b=b||"default";c=void 0==c?!0:c;var e,f=this.nRows,g=2==d?a.length:3==d?a.nCols:1;if("default"==b||"nopivot"==b){var h=c?this.copy():this,k;if(1==d||3==d)k=c?a.copy():a;else for(k=[],b=0;b<g;b++)k[b]=c?a[b].copy():a[b];for(c=0;c<f;c++)for(e=h[c][c],b=c+1;b<f;b++){for(a=c+1;a<f;a++)h[b][a]-=
h[c][a]*h[b][c]/e;switch(d){case 1:k[b]-=k[c]*h[b][c]/e;break;case 2:for(a=0;a<g;a++)k[a][b]-=k[a][c]*h[b][c]/e;break;case 3:for(a=0;a<g;a++)k[b][a]-=k[c][a]*h[b][c]/e}}for(c=f-1;0<=c;c--)for(e=h[c][c],b=c-1;0<=b;b--){for(a=f-1;a>c;a--)h[b][a]-=h[c][a]*h[b][c]/e;switch(d){case 1:k[b]-=k[c]*h[b][c]/e;break;case 2:for(a=0;a<g;a++)k[a][b]-=k[a][c]*h[b][c]/e;break;case 3:for(a=0;a<g;a++)k[b][a]-=k[c][a]*h[b][c]/e}}for(c=0;c<f;c++)switch(e=h[c][c],d){case 1:k[c]/=e;break;case 2:for(a=0;a<g;a++)k[a][c]/=
e;break;case 3:for(a=0;a<g;a++)k[c][a]/=e}return k}if("partpivot"==b){h=this.implicitPartialPivotPermutation(c);switch(d){case 1:k=c?a.copy():a;k.permuteElements(h.coeffs);break;case 2:k=[];for(b=0;b<g;b++)k[b]=c?a[b].copy():a[b],k[b].permuteElements(h.coeffs);break;case 3:k=c?a.copy():a,k.permuteRows(h.coeffs)}return h.mat.gaussJordanElimination(k,"nopivot",!1)}return this.gaussJordanElimination(a,"default",c)};
JSMatrix.Matrix.prototype.choleskyDecomposition=function(a,b){b=void 0==b?!0:b;if(!this.isSquare()||b&&!this.isSymmetric())return null;var c=this.nRows,d=void 0==a||a?this.copy():this,e,f,g,h,k;for(g=0;g<c;g++){e=d[g][g];for(k=0;k<g;k++)e-=d[g][k]*d[g][k];if(0>=e)return null;e=Math.sqrt(e);d[g][g]=e;for(h=g+1;h<c;h++){f=d[h][g];for(k=0;k<g;k++)f-=d[g][k]*d[h][k];d[h][g]=f/e}for(k=g+1;k<c;k++)d[g][k]=0}return d};JSMatrix.Matrix.prototype.chol=JSMatrix.Matrix.prototype.choleskyDecomposition;
JSMatrix.Matrix.prototype.lltDecomposition=JSMatrix.Matrix.prototype.choleskyDecomposition;
JSMatrix.Matrix.prototype.luDecomposition=function(a){if(!this.isSquare())return null;a=a||"default";var b=this.nRows,c=JSMatrix.Matrix.Zeros(b,b),d=JSMatrix.Matrix.Zeros(b,b),e,f,g;if("default"==a||"nopivot"==a){for(f=0;f<b;f++){c[f][f]=1;for(e=f;e<b;e++){g=this[f][e];for(a=0;a<f;a++)g-=c[f][a]*d[a][e];d[f][e]=g}for(e=f+1;e<b;e++){g=this[e][f];for(a=0;a<f;a++)g-=c[e][a]*d[a][f];c[e][f]=g/d[f][f]}}return{l:c,u:d}}return"partpivot"==a?(b=this.implicitPartialPivotPermutation(),c=b.mat.luDecomposition("nopivot"),
c.coeffs=b.coeffs,c):this.luDecomposition("default")};
JSMatrix.Matrix.prototype.lduDecomposition=function(a){if(!this.isSquare())return null;a=a||"default";if("default"==a||"nopivot"==a){a=this.nRows;for(var b=JSMatrix.Matrix.Zeros(a,a),c=JSMatrix.Vector.Zeros(a),d=JSMatrix.Matrix.Zeros(a,a),e,f=0;f<a;f++){b[f][f]=1;d[f][f]=1;for(var g=0;g<f;g++){e=this[f][g];for(var h=0;h<g;h++)e-=b[f][h]*c[h]*d[h][g];b[f][g]=e/c[g]}e=this[f][f];for(h=0;h<f;h++)e-=b[f][h]*c[h]*d[h][f];c[f]=e;for(g=f+1;g<a;g++){e=this[f][g];for(h=0;h<f;h++)e-=b[f][h]*c[h]*d[h][g];d[f][g]=
e/c[f]}}return{l:b,d:c,u:d}}a=this.implicitPartialPivotPermutation();b=a.mat.lduDecomposition("nopivot");b.coeffs=a.coeffs;return b};
JSMatrix.Matrix.prototype.qrDecomposition=function(a,b){if(!this.isSquare())return null;b=void 0==b?!0:b;a=a||"default";var c=this.nRows;if("default"==a||"grammschmidt"==a||"gramm-schmidt"==a||"gs"==a){var d=b?this.copy():this,e=new JSMatrix.Matrix(c,c),f,g=[],h,k;for(k=0;k<c;k++){f=d.getCol(k);g[k]=f.copy();for(h=0;h<k;h++)g[k].isub(g[h].mulf(g[h].dot(f)/g[h].dot(g[h])));g[k].normalize();for(h=0;h<=k;h++)d[h][k]=g[h].dot(f);for(h=k+1;h<c;h++)d[h][k]=0;e.setCol(k,g[k])}return{q:e,r:d}}if("householder"==
a){d=b?this.copy():this;g=JSMatrix.Vector.Zeros(c);g[0]=1;var l,e=JSMatrix.Matrix.Identity(c),m;for(k=0;k<c-1;k++)g.resize(c-k),h=JSMatrix.range(k,c),f=d.getSubMatrix(h,h),f=f.getCol(0),l=JSMatrix.Matrix.Identity(c),m=0<f[k]?-1:1,l.setSubMatrix(h,h,JSMatrix.Matrix.Householder(f.add(g.mulf(m*f.norm())))),d=l.mulm(d),e=e.mulm(l.transposed());return{q:e,r:d}}return this.qrDecomposition("default",b)};
JSMatrix.Matrix.prototype.linSolve=function(a,b,c,d){c=void 0==c?!0:c;b=(b||"default").toLowerCase();if("default"==b||"gauss"==b||"gaussian"==b)return this.gaussianElimination(a,"partpivot",c);if("gaussjordan"==b||"gauss-jordan"==b||"gj"==b)return this.gaussJordanElimination(a,"partpivot",c);if("lu"==b){var e=d||this.luDecomposition(),f=e.l,e=e.u;if(a instanceof JSMatrix.Vector)return c=f.forwardSubstitution(a,c),e.backwardSubstitution(c,!1);if(a instanceof JSMatrix.Matrix){b=c?JSMatrix.Matrix.Zeros(this.nRows,
a.nCols):a;for(d=0;d<b.nCols;d++)c=f.forwardSubstitution(a.getCol(d),!1),b.setCol(d,e.backwardSubstitution(c,!1));return b}if(a instanceof Array)return null}if("ldu"==b){e=d||this.lduDecomposition("nopivot");f=e.l;b=e.d instanceof JSMatrix.Matrix?e.d.diag():e.d;e=e.u;c=f.forwardSubstitution(a,c);for(a=0;a<this.nRows;a++)c[a]/=b[a];return e.backwardSubstitution(c,!1)}if("cholesky"==b||"chol"==b){f=d||this.choleskyDecomposition();if(null==f)return null;c=f.forwardSubstitution(a,c);return f.transposed().backwardSubstitution(c,
!1)}return"qr"==b?(f=d||this.qrDecomposition("grammschmidt",c),f.r.backwardSubstitution(f.q.transposed().mulv(a),!1)):this.linSolve(a,"default",c,d)};
JSMatrix.Matrix.prototype.schurForm=function(a,b){if(!this.isSquare())return null;var c=this.nRows;b=b||1E3;var d,e=void 0==a||a?this.copy():this,f,g=JSMatrix.Vector.Zeros(c),h=JSMatrix.Vector.Zeros(c),k=0;JSMatrix.Matrix.Identity(c);for(d=0;d<c;d++)g[d]=0;do{d=e.qrDecomposition();e=d.q;d=d.r;e=d.mulm(e);f=g.copy();g=e.diagonalToVector();for(d=0;d<c;d++)h[d]=Math.abs((g[d]-f[d])/g[d]);for(d=f=0;d<c;d++)h[d]>f&&(f=h[d]);k++;if(k>b){if(f>JSMatrix.TOL)return null;break}}while(f>JSMatrix.TOL2);return e};
JSMatrix.Matrix.prototype.schurDecomposition=function(a,b){if(!this.isSquare())return null;var c=this.nRows;b=b||1E3;var d,e=void 0==a||a?this.copy():this,f,g=JSMatrix.Vector.Zeros(c),h=JSMatrix.Vector.Zeros(c),k=0,l=JSMatrix.Matrix.Identity(c);for(d=0;d<c;d++)g[d]=0;do{d=e.qrDecomposition();e=d.q;l=l.mulm(e);d=d.r;e=d.mulm(e);f=g.copy();g=e.diagonalToVector();for(d=0;d<c;d++)h[d]=Math.abs((g[d]-f[d])/g[d]);for(d=f=0;d<c;d++)h[d]>f&&(f=h[d]);k++;if(k>b){if(f>JSMatrix.TOL)return null;break}}while(f>
JSMatrix.TOL2);return{q:l,s:e}};
JSMatrix.Matrix.prototype.singularValueDecomposition=function(){if(!this.isSquare())return null;for(var a=this.mulm(this.transposed()),b=a.nRows,c=this.transposed().mulm(this),d=c.nRows,e=a.eigSymmetric({nEigModes:"all"}),f=c.eigSymmetric({nEigModes:"all"}),a=JSMatrix.Matrix.Zeros(a.nRows,a.nCols),c=JSMatrix.Matrix.Zeros(c.nRows,c.nCols),g=0;g<b;g++)a.setCol(g,e.eigVecs[g]);for(g=0;g<d;g++)c.setCol(g,f.eigVecs[g]);b=[];for(g=0;g<d;g++)b[g]=Math.sqrt(f.eigVals[g]);return{u:a,s:JSMatrix.Vector.create(b),
v:c}};JSMatrix.Matrix.prototype.svd=JSMatrix.Matrix.prototype.singularValueDecomposition;JSMatrix.Matrix.prototype.polarDecomposition=function(a){if(!this.isSquare)return null;a=a?a:this.singularValueDecomposition();var b=a.s,c=a.v;return{r:a.u.mulm(c.transposed()),u:c.mulm(b.diag()).mulm(c.transposed())}};
JSMatrix.Matrix.prototype.eigSymmetric=function(a){if(!this.isSquare())return null;a=a||{};var b=a.mat||JSMatrix.Matrix.Identity(this.nRows);if(!b.isSquare()||!this.isSameSizeAs(b))return null;var c=a.nEigModes||this.nRows;"all"==c?c=this.nRows:c>this.nRows&&(c=this.nRows);var d=a.method||"default",e=a.highest||!1,f=a.maxiter||1E3;if("default"==d||"invit"==d){e=e?b.inv().mulm(this):this.inv().mulm(b);a=[];for(var d=[],g=[],h,k,l,m=JSMatrix.Vector.Zeros(this.nRows),n=0;n<c;n++){m.one();k=l=0;do{m=
e.mulv(m);for(h=0;h<n;h++)m.isub(d[h].mulf(g[h].dot(m)));m.imulf(1/m.energyNorm(b));h=k;k=m.squaredEnergyNorm(this)/m.squaredEnergyNorm(b);h=Math.abs((k-h)/k);l++;if(l>f){if(h>JSMatrix.TOL)return null;break}}while(h>JSMatrix.TOL2);a[n]=k;d[n]=m.copy();g[n]=m.mulm(b)}return{eigVals:a,eigVecs:d}}if("subspace"==d){a=[];d=[];h=this.nRows;var p,q;JSMatrix.Vector.Zeros(this.nRows);g=JSMatrix.Matrix.Ones(h,c);for(l=0;l<h;l++)g.set(l,l,0);m=e?b.luDecomposition():this.luDecomposition();n=[];for(h=0;h<c;h++)n[h]=
0;k=n.slice();l=0;do{g=e?b.linSolve(this.mulm(g),"lu",!1,m):this.linSolve(b.mulm(g),"lu",!1,m);h=g.transposed().mulm(this).mulm(g);p=g.transposed().mulm(b).mulm(g);p=h.eigSymmetric({mat:p,nEigModes:c,highest:e});q=JSMatrix.Matrix.Zeros(c,c);for(h=0;h<c;h++)q.setCol(h,p.eigVecs[h]);g=g.mulm(q);q=n.slice();n=p.eigVals.slice();for(h=0;h<c;h++)k[h]=Math.abs((n[h]-q[h])/n[h]);for(h=q=0;h<c;h++)k[h]>q&&(q=k[h]);l++;if(l>f){if(q>JSMatrix.TOL)return null;break}}while(q>JSMatrix.TOL2);for(l=0;l<c;l++)a.push(p.eigVals[l]),
d.push(g.getCol(l));return{eigVals:a,eigVecs:d}}a.method="default";return this.eigSymmetric(a)};JSMatrix.Matrix.prototype.eigVals=function(a){a=(a||"default").toLowerCase();return"default"==a||"schur"==a?this.schurForm().diagonalToVector().toArray():this.eigVals("default")};
JSMatrix.Matrix.prototype.eigenDecomposition=function(a,b){if(!this.isSquare)return null;a=a||"default";if("default"==a){var c,d,e=this.nRows;c=b?b:this.schurDecomposition();var f=c.q,g=c.s,h=new JSMatrix.Matrix(e,e);for(c=0;c<e;c++)h[c][c]=g[c][c];var k=JSMatrix.Matrix.Zeros(e,e),l=new JSMatrix.Matrix,m,n=new JSMatrix.Vector,p=new JSMatrix.Vector(e);k.setCol(0,f.getCol(0));for(c=1;c<e;c++){d=JSMatrix.range(c);l.beSubMatrixOf(g,d,d);m=g[c][c];n.resize(c);for(d=0;d<c;d++)l[d][d]-=m,n[d]=g[d][c];p.beSolutionOf(l,
n);p.negate();p.appendElements(1);p.resize(e);k.setCol(c,f.mulv(p))}return{p:k,l:h}}if("symm"==a||"symmeig"==a||"eigsymm"==a||"eigsymmetric"==a){e=this.nRows;f=this.eigSymmetric();k=JSMatrix.Matrix.Zeros(e,e);h=JSMatrix.Matrix.Zeros(e,e);for(c=0;c<e;c++)k.setCol(c,f.eigVecs[c]),h[c][c]=f.eigVals[c];return{p:k,l:h}}return this.eigenDecomposition("default")};JSMatrix.Matrix.prototype.spectralDecomposition=JSMatrix.Matrix.prototype.eigenDecomposition;
JSMatrix.Matrix.prototype.inversed=function(a,b){if(!this.isSquare)return null;a=(a||"default").toLowerCase();if("default"==a||"gaussjordan"==a)return this.gaussJordanElimination(JSMatrix.Matrix.Identity(this.nRows));if("lu"==a){for(var c=b?b:this.luDecomposition(),d=this.nRows,e=new JSMatrix.Matrix(d,d),f=JSMatrix.Vector.Zeros(d),g=0;g<d;g++)f.zero(),f[g]=1,this.linSolve(f,"lu",!1,c),e.setCol(g,f);return e}if("chol"==a||"cholesky"==a){c=b?b:this.choleskyDecomposition();if(null==c)return null;d=this.nRows;
e=new JSMatrix.Matrix(d,d);f=JSMatrix.Vector.Zeros(d);for(g=0;g<d;g++)f.zero(),f[g]=1,this.linSolve(f,"cholesky",!1,c),e.setCol(g,f);return e}if("eigen"==a||"eig"==a){g=b?b:this.eigenDecomposition();d=g.p;c=g.l;for(g=0;g<this.nRows;g++)c[g][g]=1/c[g][g];return d.mulm(c).mulm(d.inversed())}if("symmeig"==a||"eigsymm"==a||"eigsymmetric"==a){g=b?b:this.eigenDecomposition("symm");d=g.p;c=g.l;for(g=0;g<this.nRows;g++)c[g][g]=1/c[g][g];return d.mulm(c).mulm(d.transposed())}if("svd"==a){for(var g=b?b:this.singularValueDecomposition(),
e=g.u,f=g.s,c=g.v,d=f.nElements,h=new JSMatrix.Matrix(d,d),g=0;g<d;g++)f[g]>JSMatrix.TOL&&(h[g][g]=1/f[g]);return c.mulm(h).mulm(e.transposed())}return this.inversed("default")};JSMatrix.Matrix.prototype.inv=JSMatrix.Matrix.prototype.inversed;
JSMatrix.Matrix.prototype.beInverseOf=function(a,b,c){a.isSquare()&&(b=(b||"default").toLowerCase(),"default"==b||"gaussjordan"==b?(b=a.copy(),this.beUnitMatrix(a.nRows),b.gaussJordanElimination(this,"nopivot",!1)):(this.beCopyOf(a.inversed(b,c)),this.beInverseOf(a,"default",c)))};
JSMatrix.Matrix.prototype.determinant=function(a,b){if(!this.isSquare())return null;a=(a||"default").toLowerCase();if("default"==a||"lu"==a)return(b?b[1]:this.luDecomposition().u).diagProduct();if("schurform"==a||"schur"==a){var c=b?b:this.schurForm();return c.diagProduct()}return"schurdecomposition"==a?(c=b?b:this.schurDecomposition().s,c.diagProduct()):"eigen"==a||"eigendecomposition"==a?(b?b.l:this.eigenDecomposition().l).diagProduct():this.determinant("default",b)};
JSMatrix.Matrix.prototype.det=JSMatrix.Matrix.prototype.determinant;JSMatrix.Matrix.prototype.giveDeterminant=JSMatrix.Matrix.prototype.determinant;JSMatrix.Matrix.create=function(a){if(void 0==a||0==a.length)return new JSMatrix.Matrix;var b=a.length,c=a[0].length,d,e,f=new JSMatrix.Matrix;for(d=0;d<b;d++)for(f[d]={},e=0;e<c;e++)f[d][e]=a[d][e];f.nRows=b;f.nCols=c;return f};
JSMatrix.Matrix.Diagonal=function(a){for(var b=void 0==a.nElements?a.length:a.nElements,c=new JSMatrix.Matrix(b,b),d=0;d<b;d++)c[d][d]=a[d];return c};JSMatrix.Matrix.Identity=function(a){for(var b=new JSMatrix.Matrix(a,a),c=0;c<a;c++)b[c][c]=1;return b};JSMatrix.Matrix.I=JSMatrix.Matrix.Identity;JSMatrix.Matrix.UnitMatrix=JSMatrix.Matrix.Identity;JSMatrix.Matrix.Zeros=function(a,b){return new JSMatrix.Matrix(a,b)};
JSMatrix.Matrix.Ones=function(a,b){a=a||0;b=b||0;for(var c=new JSMatrix.Matrix,d=0;d<a;d++){c[d]={};for(var e=0;e<b;e++)c[d][e]=1}c.nRows=a;c.nCols=b;return c};JSMatrix.Matrix.Householder=function(a,b){var c=a.nElements;return(b?b:JSMatrix.Matrix.Identity(c)).sub(a.dyadic(a).mulf(2/a.dot(a)))};JSMatrix.mat=JSMatrix.Matrix.create;JSMatrix.vec=JSMatrix.Vector.create;JSMatrix.zeros=function(a,b){return b?JSMatrix.Matrix.Zeros(a,b):a?JSMatrix.Vector.Zeros(a):null};
JSMatrix.ones=function(a,b){return b?JSMatrix.Matrix.Ones(a,b):a?JSMatrix.Vector.Ones(a):null};JSMatrix.identity=JSMatrix.Matrix.Identity;JSMatrix.eye=JSMatrix.Matrix.Identity;JSMatrix.unitMatrix=JSMatrix.Matrix.Identity;JSMatrix.linSolve=function(a,b,c,d,e){return a.linSolve(b,c,d,e)};JSMatrix.eigSymmetric=function(a){return a.mat1.eigSymmetric({mat:a.mat2,nEigModes:a.nEigModes,method:a.method,highest:a.highest,maxiter:a.maxiter})};
JSMatrix.range=function(a,b,c){var d;void 0===b&&void 0===c?(d=0,c=1):void 0===c?(d=a,a=b,c=1):(d=a,a=b);for(b=[];d<a;)b.push(d),d+=c;return b};void 0===Array.prototype.indexOf&&(Array.prototype.indexOf=function(a){for(var b=0;b<this.length;b++)if(this[b]===a)return b;return-1});Array.prototype.setdiff=function(a){for(var b=[],c=0;c<this.length;c++){for(var d=1,e=0;e<a.length;e++)if(this[c]==a[e]){d=0;break}d&&b.push(this[c])}return b};
