/*
*
*             Raphaël3d : Raphaël extension for basic 3d graphics           
*                                                                             
*                          version 0.9.dev (2014-08-20)                       
*  
*                    Copyright (C)  2013 - 2014  Jan Stransky                 
*  
*           Czech Technical University, Faculty of Civil Engineering,         
*       Department of Structural Mechanics, 166 29 Prague, Czech Republic     
*  
*  Raphaël3d is free software: you can redistribute it and/or modify it under
*  the terms of the GNU Lesser General Public License as published by the Free
*  Software Foundation, either version 3 of the License, or (at your option)
*  any later version.
*  
*  Raphaël3d is distributed in the hope that it will be useful, but WITHOUT
*  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
*  FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
*  for more details.
*  
*  You should have received a copy of the GNU Lesser General Public License
*  along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
var Raphael3d={TOL:1E-9,__setIdentityMatrix4x4:function(a){a.m00=1;a.m01=0;a.m02=0;a.m03=0;a.m10=0;a.m11=1;a.m12=0;a.m13=0;a.m20=0;a.m21=0;a.m22=1;a.m23=0;a.m30=0;a.m31=0;a.m32=0;a.m33=1},__isCoveredBy:function(a,b){for(var c=a.coveredByList.length,d=0;d<c;d++)if(a.coveredByList[d]==b)return!0;return!1},Matrix4x4:function(){Raphael3d.__setIdentityMatrix4x4(this)}};Raphael3d.Matrix4x4.create=function(){return new Raphael3d.Matrix4x4};
Raphael3d.Matrix4x4.prototype.toString=function(){return"Matrix4x4( "+this.m00+", "+this.m01+", "+this.m02+", "+this.m03+";\n           "+this.m10+", "+this.m11+", "+this.m12+", "+this.m13+";\n           "+this.m20+", "+this.m21+", "+this.m22+", "+this.m23+";\n           "+this.m30+", "+this.m31+", "+this.m32+", "+this.m33+")"};Raphael3d.Matrix4x4.prototype.beIdentity=function(){Raphael3d.__setIdentityMatrix4x4(this);return this};
Raphael3d.Matrix4x4.prototype.beCopyOf=function(a){this.m00=a.m00;this.m01=a.m01;this.m02=a.m02;this.m03=a.m03;this.m10=a.m10;this.m11=a.m11;this.m12=a.m12;this.m13=a.m13;this.m20=a.m20;this.m21=a.m21;this.m22=a.m22;this.m23=a.m23;this.m30=a.m30;this.m31=a.m31;this.m32=a.m32;this.m33=a.m33;return this};
Raphael3d.Matrix4x4.prototype.copy=function(){var a=new Raphael3d.Matrix4x4;a.m00=this.m00;a.m01=this.m01;a.m02=this.m02;a.m03=this.m03;a.m10=this.m10;a.m11=this.m11;a.m12=this.m12;a.m13=this.m13;a.m20=this.m20;a.m21=this.m21;a.m22=this.m22;a.m23=this.m23;a.m30=this.m30;a.m31=this.m31;a.m32=this.m32;a.m33=this.m33;return a};
Raphael3d.Matrix4x4.prototype.mul=function(a){if(!a)return this;var b=a.m00*this.m01+a.m01*this.m11+a.m02*this.m21+a.m03*this.m31,c=a.m00*this.m02+a.m01*this.m12+a.m02*this.m22+a.m03*this.m32,d=a.m00*this.m03+a.m01*this.m13+a.m02*this.m23+a.m03*this.m33,e=a.m10*this.m00+a.m11*this.m10+a.m12*this.m20+a.m13*this.m30,f=a.m10*this.m01+a.m11*this.m11+a.m12*this.m21+a.m13*this.m31,g=a.m10*this.m02+a.m11*this.m12+a.m12*this.m22+a.m13*this.m32,h=a.m10*this.m03+a.m11*this.m13+a.m12*this.m23+a.m13*this.m33,
k=a.m20*this.m00+a.m21*this.m10+a.m22*this.m20+a.m23*this.m30,l=a.m20*this.m01+a.m21*this.m11+a.m22*this.m21+a.m23*this.m31,m=a.m20*this.m02+a.m21*this.m12+a.m22*this.m22+a.m23*this.m32,n=a.m20*this.m03+a.m21*this.m13+a.m22*this.m23+a.m23*this.m33,q=a.m30*this.m00+a.m31*this.m10+a.m32*this.m20+a.m33*this.m30,r=a.m30*this.m01+a.m31*this.m11+a.m32*this.m21+a.m33*this.m31,s=a.m30*this.m02+a.m31*this.m12+a.m32*this.m22+a.m33*this.m32,t=a.m30*this.m03+a.m31*this.m13+a.m32*this.m23+a.m33*this.m33;this.m00=
a.m00*this.m00+a.m01*this.m10+a.m02*this.m20+a.m03*this.m30;this.m01=b;this.m02=c;this.m03=d;this.m10=e;this.m11=f;this.m12=g;this.m13=h;this.m20=k;this.m21=l;this.m22=m;this.m23=n;this.m30=q;this.m31=r;this.m32=s;this.m33=t;return this};Raphael3d.Matrix4x4.prototype.translate=function(a,b,c){this.mul(Raphael3d.Matrix4x4.TranslationMatrix(a,b,c));return this};Raphael3d.Matrix4x4.prototype.scale=function(a,b,c){this.mul(Raphael3d.Matrix4x4.ScaleMatrix(a,b,c));return this};
Raphael3d.Matrix4x4.prototype.zoom=function(a){this.mul(Raphael3d.Matrix4x4.ZoomMatrix(a));return this};Raphael3d.Matrix4x4.prototype.shear=function(a,b,c){this.mul(Raphael3d.Matrix4x4.ShearMatrix(a,b,c));return this};Raphael3d.Matrix4x4.prototype.rotateX=function(a,b){this.mul(Raphael3d.Matrix4x4.RotationXMatrix(a,b));return this};Raphael3d.Matrix4x4.prototype.rotateY=function(a,b){this.mul(Raphael3d.Matrix4x4.RotationYMatrix(a,b));return this};
Raphael3d.Matrix4x4.prototype.rotateZ=function(a,b){this.mul(Raphael3d.Matrix4x4.RotationZMatrix(a,b));return this};Raphael3d.Matrix4x4.prototype.rotate=function(a,b,c){this.mul(Raphael3d.Matrix4x4.RotationMatrix(a,b,c));return this};Raphael3d.Matrix4x4.Identity=function(){return new Raphael3d.Matrix4x4};Raphael3d.Matrix4x4.TranslationMatrix=function(a,b,c){var d=Raphael3d.Matrix4x4.Identity();d.m03=a;d.m13=b;d.m23=c;return d};
Raphael3d.Matrix4x4.RotationXMatrix=function(a,b){var c=Raphael3d.Matrix4x4.Identity(),d=Math.cos(a),e=Math.sin(a);c.m11=d;c.m12=-e;c.m21=e;c.m22=d;b&&(c=Raphael3d.Matrix4x4.TranslationMatrix(-b.x,-b.y,-b.z).mul(c).mul(Raphael3d.Matrix4x4.TranslationMatrix(b.x,b.y,b.z)));return c};
Raphael3d.Matrix4x4.RotationYMatrix=function(a,b){var c=Raphael3d.Matrix4x4.Identity(),d=Math.cos(a),e=Math.sin(a);c.m00=d;c.m02=-e;c.m20=e;c.m22=d;b&&(c=Raphael3d.Matrix4x4.TranslationMatrix(-b.x,-b.y,-b.z).mul(c).mul(Raphael3d.Matrix4x4.TranslationMatrix(b.x,b.y,b.z)));return c};
Raphael3d.Matrix4x4.RotationZMatrix=function(a,b){var c=Raphael3d.Matrix4x4.Identity(),d=Math.cos(a),e=Math.sin(a);c.m00=d;c.m01=-e;c.m10=e;c.m11=d;b&&(c=Raphael3d.Matrix4x4.TranslationMatrix(-b.x,-b.y,-b.z).mul(c).mul(Raphael3d.Matrix4x4.TranslationMatrix(b.x,b.y,b.z)));return c};
Raphael3d.Matrix4x4.RotationMatrix=function(a,b,c){var d=Raphael3d.Matrix4x4.Identity(),e=Math.cos(b);b=Math.sin(b);var f=1-e,g=a.x,h=a.y;a=a.z;d.m00=e+f*g*g;d.m01=f*g*h-b*a;d.m02=f*g*a+b*h;d.m10=f*h*g+b*a;d.m11=e+f*h*h;d.m12=f*h*a-b*g;d.m20=f*a*g-b*h;d.m21=f*a*h+b*g;d.m22=e+f*a*a;c&&(d=Raphael3d.Matrix4x4.TranslationMatrix(-c.x,-c.y,-c.z).mul(d).mul(Raphael3d.Matrix4x4.TranslationMatrix(c.x,c.y,c.z)));return d};
Raphael3d.Matrix4x4.ScaleMatrix=function(a,b,c){var d=Raphael3d.Matrix4x4.Identity();d.m00=a;d.m11=b;d.m22=c;return d};Raphael3d.Matrix4x4.ZoomMatrix=function(a){return Raphael3d.Matrix4x4.ScaleMatrix(a,a,a)};Raphael3d.Matrix4x4.ShearMatrix=function(a,b,c){var d=Raphael3d.Matrix4x4.Identity();d.m01=d.m10=0.5*a;d.m12=d.m21=0.5*b;d.m20=d.m02=0.5*c;return d};Raphael3d.Matrix4x4.PerspectiveMatrixZ=function(a){var b=Raphael3d.Matrix4x4.Identity();b.m32=1/a;return b};
Raphael3d.Vector3=function(a,b,c){this.x=a||0;this.y=b||0;this.z=c||0};Raphael3d.Vector3.create=function(a,b,c){return new Raphael3d.Vector3(a,b,c)};Raphael3d.Vector3.prototype.add=function(a){return new Raphael3d.Vector3(this.x+a.x,this.y+a.y,this.z+a.z)};Raphael3d.Vector3.prototype.sub=function(a){return new Raphael3d.Vector3(this.x-a.x,this.y-a.y,this.z-a.z)};Raphael3d.Vector3.prototype.dot=function(a){return this.x*a.x+this.y*a.y+this.z*a.z};Raphael3d.Vector3.prototype.norm=function(){return Math.sqrt(this.dot(this))};
Raphael3d.Vector3.prototype.cross=function(a){return new Raphael3d.Vector3(this.y*a.z-this.z*a.y,this.z*a.x-this.x*a.z,this.x*a.y-this.y*a.x)};Raphael3d.Vector3.prototype.normalize=function(){var a=this.norm();this.x/=a;this.y/=a;this.z/=a};Raphael3d.Vector3.prototype.beCopyOf=function(a){this.x=a.x;this.y=a.y;this.z=a.z;return this};Raphael3d.Vector3.prototype.copy=function(){return new Raphael3d.Vector3(this.x,this.y,this.z)};
Raphael3d.Vector3.prototype.toString=function(){return"Vector3( "+this.x+", "+this.y+", "+this.z+" )"};Raphael3d.Vector3.prototype.isEqualTo=function(a){return Math.abs(this.x-a.x)<Raphael3d.TOL&&Math.abs(this.y-a.y)<Raphael3d.TOL&&Math.abs(this.z-a.z)<Raphael3d.TOL};Raphael3d.Vector3.prototype.setCoordinates=function(a,b,c){this.x=a;this.y=b;this.z=c;return this};Raphael3d.Vector3.UnitX=function(){return new Raphael3d.Vector3(1,0,0)};
Raphael3d.Vector3.UnitY=function(){return new Raphael3d.Vector3(0,1,0)};Raphael3d.Vector3.UnitZ=function(){return new Raphael3d.Vector3(0,0,1)};Raphael3d.Vertex=function(a,b,c){Raphael3d.Vector3.call(this,a,b,c);this.projected=new Raphael3d.Vector3(this.x,this.y,this.z);this.edges=[];this.faces=[]};Raphael3d.Vertex.prototype.__type="Vertex";Raphael3d.Vertex.create=function(a,b,c){return new Raphael3d.Vertex(a,b,c)};Raphael3d.Vertex.prototype.add=Raphael3d.Vector3.prototype.add;
Raphael3d.Vertex.prototype.sub=Raphael3d.Vector3.prototype.sub;Raphael3d.Vertex.prototype.dot=Raphael3d.Vector3.prototype.dot;Raphael3d.Vertex.prototype.cross=Raphael3d.Vector3.prototype.cross;Raphael3d.Vertex.prototype.isEqualTo=Raphael3d.Vector3.prototype.isEqualTo;Raphael3d.Vertex.prototype.setCoordinates=Raphael3d.Vector3.prototype.setCoordinates;
Raphael3d.Vertex.prototype.transform=function(a){if(a){var b,c,d;a?(b=a.m00*this.x+a.m01*this.y+a.m02*this.z+a.m03,c=a.m10*this.x+a.m11*this.y+a.m12*this.z+a.m13,d=a.m20*this.x+a.m21*this.y+a.m22*this.z+a.m23,a=a.m30*this.x+a.m31*this.y+a.m32*this.z+a.m33):(b=this.x,c=this.y,d=this.z,a=1);this.x=b/a;this.y=c/a;this.z=d/a}};
Raphael3d.Vertex.prototype.project=function(a){var b,c,d;a?(b=a.m00*this.x+a.m01*this.y+a.m02*this.z+a.m03,c=a.m10*this.x+a.m11*this.y+a.m12*this.z+a.m13,d=a.m20*this.x+a.m21*this.y+a.m22*this.z+a.m23,a=a.m30*this.x+a.m31*this.y+a.m32*this.z+a.m33):(b=this.x,c=this.y,d=this.z,a=1);this.projected.x=b/a;this.projected.y=c/a;this.projected.z=d/a};Raphael3d.Vertex.prototype.giveNeighbors=function(){for(var a=[],b=this.edges.length,c=0;c<b;c++)a.push(this.edges[c].give2ndVertex(this));return a};
Raphael3d.Vertex.prototype.isNeighborOf=function(a){for(var b=this.edges.length,c,d=0;d<b;d++)if(c=this.edges[d],a==c.v1||a==c.v2)return!0;return!1};Raphael3d.Vertex.prototype.giveCommonEdgeWith=function(a){for(var b=this.edges.length,c,d=0;d<b;d++)if(c=this.edges[d],a==c.v1||a==c.v2)return c;return null};Raphael3d.Vertex.prototype.connectWith=function(a,b,c){var d=this.giveCommonEdgeWith(a);null===d&&(d=new Raphael3d.Edge(this,a,b,c));return d};
Raphael3d.Vertex.prototype.computeDistFromFace=function(a,b){b&&a.update();var c=a.normal;return this.sub(a.vertices[0]).dot(c)};Raphael3d.Vertex.prototype.computeSqrDistFromVertex=function(a){a=this.sub(a);return a.dot(a)};Raphael3d.Vertex.prototype.computeDistFromVertex=function(a){return Math.sqrt(this.computeSqrDistFromVertex(a))};Raphael3d.Vertex.prototype.fromVector3=function(a){this.x=a.x;this.y=a.y;this.z=a.z;this.projected.beCopyOf(a);return this};Raphael3d.Vertex.FromVector3=function(a){return(new Raphael3d.Vertex).fromVector3(a)};
Raphael3d.Edge=function(a,b,c,d){this.v1=a;this.v2=b;a.edges.push(this);b.edges.push(this);this.path=c&&d?c.path().attr({"stroke-width":0}).attr(d):null;this.faces=[];this.isBackFace=this.isBoundary=!1;this.aabbProjected=this.aabb=null;this.coveredByList=[]};Raphael3d.Edge.prototype.__type="Edge";Raphael3d.Edge.create=function(a,b,c,d){return new Raphael3d.Edge(a,b,c,d)};
Raphael3d.Edge.prototype.update=function(){var a=this.faces;this.isBoundary=2==a.length&&(a[0].isBackFace&&!a[1].isBackFace||!a[0].isBackFace&&a[1].isBackFace);this.isBackFace=2==a.length&&a[0].isBackFace&&a[1].isBackFace;return this};Raphael3d.Edge.prototype.computeLengthSqr=function(){var a=this.v2.sub(this.v1);return a.dot(a)};Raphael3d.Edge.prototype.computeLength=function(){return Math.sqrt(this.computeLengthSqr)};
Raphael3d.Edge.prototype.computeProjectedLengthSqr=function(){var a=this.v2.projected.sub(this.v1.projected);return a.x*a.x+a.y*a.y};Raphael3d.Edge.prototype.computeProjectedLength=function(){return Math.sqrt(this.computeProjectedLengthSqr)};Raphael3d.Edge.prototype.isProjectedZParallel=function(){var a=this.v1.projected,b=this.v2.projected,c=Raphael3d.TOL;return Math.abs(a.x-b.x)<c&&Math.abs(a.y-b.y)<c};
Raphael3d.Edge.prototype.render=function(){this.path&&this.path.attr({path:["M",this.v1.projected.x,this.v1.projected.y,"L",this.v2.projected.x,this.v2.projected.y]})};Raphael3d.Edge.prototype.give2ndVertex=function(a){return a==this.v1?this.v2:a==this.v2?this.v1:null};Raphael3d.Edge.prototype.giveNeighbors=function(){for(var a=this.v1.edges.slice(0),b=a.length,c=0;c<b&&a[c]!=this;c++);a.splice(c,1);for(var d=this.v1.edges.slice(0),b=d.length,c=0;c<b&&d[c]!=this;c++);d.splice(c,1);return a.concat(d)};
Raphael3d.Edge.prototype.isNeighborOf=function(a){for(var b=this.v1.edges.length,c=0;c<b;c++)if(this.v1.edges[c]==a)return!0;b=this.v2.edges.length;for(c=0;c<b;c++)if(this.v2.edges[c]==a)return!0;return!1};Raphael3d.Edge.prototype.transform=function(a){this.v1.transform(a);this.v2.transform(a);return this};Raphael3d.Edge.prototype.project=function(a){if(!a)return this;this.v1.project(a);this.v2.project(a);return this};
Raphael3d.Edge.prototype.updateAABB=function(){this.aabb&&this.aabbProjected||(this.aabb=new Raphael3d.AABB,this.aabbProjected=new Raphael3d.AABB);var a=this.v1,b=this.v2,c=Math.min(a.x,b.x),d=Math.min(a.y,b.y),e=Math.min(a.z,b.z),f=Math.max(a.x,b.x),g=Math.max(a.y,b.y),b=Math.max(a.z,b.z);this.aabb.setVals(c,d,e,f,g,b);a=a.projected;b=this.v2.projected;c=Math.min(a.x,b.x);d=Math.min(a.y,b.y);e=Math.min(a.z,b.z);f=Math.max(a.x,b.x);g=Math.max(a.y,b.y);b=Math.max(a.z,b.z);this.aabbProjected.setVals(c,
d,e,f,g,b);return this};Raphael3d.Edge.prototype.isCoveredBy=function(a){return Raphael3d.__isCoveredBy(this,a)};Raphael3d.Edge.prototype.isInFrontOf=function(a){var b;"Edge"==a.__type&&(b=this.isInFrontOfEdge(a));"Face"==a.__type&&(b=this.isInFrontOfFace(a));"Surface"==a.__type&&(b=this.isInFrontOfSurface(a));return 1==b?!0:!1};
Raphael3d.Edge.prototype.isInFrontOfEdge=function(a){var b=this.v1.projected,c=this.v2.projected,d=a.v1.projected;a=a.v2.projected;if(b.isEqualTo(d)||b.isEqualTo(a)||c.isEqualTo(d)||c.isEqualTo(a))return 0;c={x:c.x-b.x,y:c.y-b.y,z:c.z-b.z};a={x:a.x-d.x,y:a.y-d.y,z:a.z-d.z};var e=Raphael3d.Geom.compute2dEdgeEdgeIntersection(b,c,d,a);if(!e||e.parallel)return 0;var f=e.param1,e=e.param2;if(0>f||1<f||0>e||1<e)return 0;b=b.z+f*c.z-(d.z+e*a.z);return b<-Raphael3d.TOL?1:b>Raphael3d.TOL?-1:0};
Raphael3d.Edge.prototype.isInFrontOfFace=function(a){var b=this.v2,c=-a.isInFrontOfVertex(this.v1);if(c||(c=-a.isInFrontOfVertex(b)))return c;a=a.edges;for(var b=a.length,d,e=c=0;e<b;e++)d=a[e],d=this.isInFrontOfEdge(d),c+=d;return 0<c?1:0>c?-1:0};Raphael3d.Edge.prototype.isInFrontOfSurface=function(a){a=a.faces;for(var b=a.length,c,d=0,e=0;e<b;e++)c=this.isInFrontOfFace(a[e]),d+=c;return 0<d?1:0>d?-1:0};
Raphael3d.Face=function(a,b,c,d){this.vertices=void 0===a?[]:a.slice();a=this.vertices.length-1;this.edges=Array(a+1);for(var e=0;e<a;e++)this.edges[e]=this.vertices[e].connectWith(this.vertices[e+1],b,d),this.vertices[e].faces.push(this),this.edges[e].faces.push(this);this.edges[a]=this.vertices[a].connectWith(this.vertices[0],b,d);this.vertices[a].faces.push(this);this.edges[a].faces.push(this);this.path=b&&c?b.path().attr({"stroke-width":0}).attr(c):null;this.isBackFace=!1;this.material=null;this.normal=
new Raphael3d.Vector3(NaN,NaN,NaN);this.projectedNormal=new Raphael3d.Vector3(NaN,NaN,NaN);this.color=null;this.transparency=0;this.isDoubleSided=!0;this.aabbProjected=this.aabb=null;this.coveredByList=[]};Raphael3d.Face.prototype.__type="Face";Raphael3d.Face.create=function(a,b,c,d){return new Raphael3d.Face(a,b,c,d)};Raphael3d.Face.prototype.isProjectedZParallel=function(){return Math.abs(this.projectedNormal.z)<Raphael3d.TOL};
Raphael3d.Face.prototype.update=function(a){this.computeNormal();this.computeProjectedNormal();if(a=this.material||a)this.color=a.computeColor(-this.projectedNormal.z),this.transparency=a.transparency;this.isBackFace=0<this.projectedNormal.z?!0:!1;a=this.edges;for(var b=a.length,c=0;c<b;c++)a[c].update()};
Raphael3d.Face.prototype.render=function(){if(this.path){var a=this.vertices.length,b=Array(3*a+1);b[0]="M";b[1]=this.vertices[0].projected.x;b[2]=this.vertices[0].projected.y;b[3*a]="Z";for(var c=1;c<a;c++)b[3*c]="L",b[3*c+1]=this.vertices[c].projected.x,b[3*c+2]=this.vertices[c].projected.y;c={path:b,opacity:1-this.transparency};this.color&&(c.fill=this.color);this.path.attr(c);for(var a=this.edges,b=a.length,d,c=0;c<b;c++)d=a[c],d.path&&(d.path.insertBefore(this.path),d.render())}};
Raphael3d.Face.prototype.computeNormal=function(){var a=this.vertices[0],b=this.vertices[this.vertices.length-1],a=this.vertices[1].sub(a).cross(b.sub(a));a.normalize();return this.normal=a};Raphael3d.Face.prototype.computeProjectedNormal=function(){var a=this.vertices[0].projected,b=this.vertices[this.vertices.length-1].projected,a=this.vertices[1].projected.sub(a).cross(b.sub(a));a.normalize();return this.projectedNormal=a};Raphael3d.Face.prototype.setMaterial=function(a){this.material=a;return this};
Raphael3d.Face.prototype.transform=function(a){for(var b=this.vertices.length,c=0;c<b;c++)this.vertices[c].transform(a);return this};Raphael3d.Face.prototype.project=function(a){if(!a)return this;for(var b=this.vertices.length,c=0;c<b;c++)this.vertices[c].project(a);return this};
Raphael3d.Face.prototype.updateAABB=function(){this.aabb&&this.aabbProjected||(this.aabb=new Raphael3d.AABB,this.aabbProjected=new Raphael3d.AABB);var a=this.vertices,b=a.length,c,d,e,f,g,h,k,l,m;c=d=e=Number.POSITIVE_INFINITY;f=g=h=Number.NEGATIVE_INFINITY;for(var n=0;n<b;n++)m=a[n],k=m.x,l=m.y,m=m.z,c=Math.min(k,c),d=Math.min(l,d),e=Math.min(m,e),f=Math.max(k,f),g=Math.max(l,g),h=Math.max(m,h);this.aabb.setVals(c,d,e,f,g,h);c=d=e=Number.POSITIVE_INFINITY;f=g=h=Number.NEGATIVE_INFINITY;for(n=0;n<
b;n++)m=a[n].projected,k=m.x,l=m.y,m=m.z,c=Math.min(k,c),d=Math.min(l,d),e=Math.min(m,e),f=Math.max(k,f),g=Math.max(l,g),h=Math.max(m,h);this.aabbProjected.setVals(c,d,e,f,g,h)};Raphael3d.Face.prototype.isCoveredBy=function(a){return Raphael3d.__isCoveredBy(this,a)};
Raphael3d.Face.prototype.projectionContainsCoords=function(a,b){for(var c=new Raphael3d.Geom.OrientedLine2d({x:a,y:b},{x:0.6525422454245,y:0.325365745522162}),d=this.edges,e=d.length,f=0,g=0;g<e;g++)c.hasIntersectionWithProjEdge(d[g])&&(f+=1);return 0!=f%2};Raphael3d.Face.prototype.projectionContainsVertex=function(a){return this.projectionContainsCoords(a.projected.x,a.projected.y)};
Raphael3d.Face.prototype.isInFrontOf=function(a){var b;if("Edge"==a.__type)return-1==a.isInFrontOfFace(this)?!0:!1;"Face"==a.__type&&(b=this.isInFrontOfFace(a));"Surface"==a.__type&&(b=this.isInFrontOfSurface(a));return 1==b?!0:!1};
Raphael3d.Face.prototype.isInFrontOfVertex=function(a){for(var b=a.projected,c=this.vertices,d=c.length,e=this.vertices[0].projected,f=this.projectedNormal,g=0;g<d;g++)if(c[g].isEqualTo(a))return 0;if(!this.projectionContainsVertex(a))return 0;c=Raphael3d.temp.plane;c.fromFace(this);if(c.containsPoint(a))return 0;a=(-f.x*b.x-f.y*b.y-(-f.x*e.x-f.y*e.y-f.z*e.z))/f.z-b.z;return a<-Raphael3d.TOL?1:a>Raphael3d.TOL?-1:0};
Raphael3d.Face.prototype.isInFrontOfFace=function(a){for(var b=0,c=this.edges,d=c.length,e,f=0;f<d;f++)e=c[f],e=e.isInFrontOfFace(a),b+=e;if(0<b)return 1;if(0>b)return-1;c=a.edges;d=c.length;for(f=0;f<d;f++)e=c[f],e=e.isInFrontOfFace(this),b-=e;return 0<b?1:0>b?-1:0};Raphael3d.Face.prototype.isInFrontOfSurface=function(a){a=a.faces;for(var b=a.length,c,d=0,e=0;e<b;e++)c=this.isInFrontOfFace(a[e]),d+=c;return 0<d?1:0>d?-1:0};
Raphael3d.Surface=function(a,b,c){this.vertices=void 0===a?[]:a.slice();this.faces=void 0===b?[]:b.slice();this.faceNormals=[];this.projectedFaceNormals=[];this.wireframe=c?c.path().attr({"stroke-linejoin":"bevel"}):null;this.wireframeBackface=c?c.path().attr({"stroke-linejoin":"bevel"}):null;this.material=null;this.aabb=new Raphael3d.AABB;this.aabbProjected=new Raphael3d.AABB;this.isDoubleSided=this.isConvex=!0;this.path=c?c.path().hide():null;this.coveredByList=[]};
Raphael3d.Surface.prototype.__type="Surface";Raphael3d.Surface.prototype.isProjectedZParallel=function(){return!1};Raphael3d.Surface.create=function(a,b,c){return new Raphael3d.Surface(a,b,c)};Raphael3d.Surface.prototype.setDoubleSidedTo=function(a){this.isDoubleSided=a;for(var b=this.faces,c=b.length,d=0;d<c;d++)b[d].isDoubleSided=a;return this};Raphael3d.Surface.prototype.hideWireframe=function(){this.wireframe&&this.wireframe.hide();this.wireframeBackface&&this.wireframeBackface.hide();return this};
Raphael3d.Surface.prototype.showWireframe=function(){this.wireframe&&this.wireframe.show();this.wireframeBackface&&this.wireframeBackface.show();return this};Raphael3d.Surface.prototype.project=function(a){if(!a)return this;for(var b=this.vertices.length,c=0;c<b;c++)this.vertices[c].project(a);return this};Raphael3d.Surface.prototype.update=function(a){this.updateFaces(a);return this};
Raphael3d.Surface.prototype.updateFaces=function(a){a=this.material||a;this.updateFaceNormals();for(var b=this.faces.length,c=0;c<b;c++)this.faces[c].update(a);this.orderFaces()};Raphael3d.Surface.prototype.render=function(a){this.renderWireframeBackface();this.renderFaces();this.renderWireframe(a);return this};Raphael3d.Surface.prototype.renderFaces=function(){if(this.path)for(var a=this.faces,b,c=a.length-1;0<=c;c--)b=a[c],b.path&&(b.path.insertBefore(this.path),b.render())};
Raphael3d.Surface.prototype.updateFaceNormals=function(){if(this.faceNormals.length==this.projectedFaceNormals.length!=this.faces.length){for(var a=this.faces,b=a.length,c=Array(b),d=Array(b),e=0;e<b;e++)c[e]=a[e].normal,d[e]=a[e].projectedNormal;this.faceNormals=c;this.projectedFaceNormals=d}};
Raphael3d.Surface.prototype.renderWireframe=function(a){if(this.wireframe&&this.path){this.wireframe.insertBefore(this.path);for(var b=this.faces,c=this.faces.length,d=0,e=0;e<c;e++)a&&!b[e].isBackFace&&(d+=b[e].vertices.length);for(var b=Array(3*d+c),f,g=0,e=0;e<c;e++)if(d=this.faces[e],!a||!d.isBackFace){f=d.vertices;d=f.length;b[g]="M";b[g+1]=f[0].projected.x;b[g+2]=f[0].projected.y;for(var g=g+3,h=1;h<d;h++)b[g]="L",b[g+1]=f[h].projected.x,b[g+2]=f[h].projected.y,g+=3;b[g]=["Z"];g+=1}this.wireframe.attr({path:b})}};
Raphael3d.Surface.prototype.renderWireframeBackface=function(){if(this.wireframeBackface&&this.path){this.wireframe.insertBefore(this.path);for(var a=this.faces,b=this.faces.length,c,d,e=0,f,g=0;g<b;g++)if(a[g].isBackFace){d=a[g];d=d.edges;f=d.length;for(var h=0;h<f;h++)c=d[h],c.isBackFace&&(e+=1)}if(0==e)a=["M",0,0,"h",0];else for(var a=Array(2*e),k,g=e=0;g<b;g++)if(d=this.faces[g],d.isBackFace)for(d=d.edges,f=d.length,h=0;h<f;h++)c=d[h],c.isBackFace&&(k=c.v1,c=c.v2,a[e]="M",a[e+1]=k.projected.x,
a[e+2]=k.projected.y,a[e+3]="L",a[e+4]=c.projected.x,a[e+5]=c.projected.y,e+=6);this.wireframeBackface.attr({path:a})}};Raphael3d.Surface.prototype.transform=function(a){for(var b=this.vertices.length,c=0;c<b;c++)this.vertices[c].transform(a);return this};Raphael3d.Surface.prototype.translate=function(a,b,c){this.transform(Raphael3d.Matrix4x4.TranslationMatrix(a,b,c));return this};Raphael3d.Surface.prototype.scale=function(a,b,c){this.transform(Raphael3d.Matrix4x4.ScaleMatrix(a,b,c));return this};
Raphael3d.Surface.prototype.shear=function(a,b,c){this.transform(Raphael3d.Matrix4x4.ShearMatrix(a,b,c));return this};Raphael3d.Surface.prototype.orderFaces=function(){if(this.isConvex)for(var a=this.faces,b=a.length,c=0,d=b-1,e;;){for(;!a[c].isBackFace&&c<=b-2;)c+=1;for(;a[d].isBackFace&&1<=d;)d-=1;if(c>=d)break;e=a[c];a[c]=a[d];a[d]=e}};Raphael3d.Surface.prototype.setWireframe=function(a){this.wireframe=a;return this};Raphael3d.Surface.prototype.setMaterial=function(a){this.material=a;return this};
Raphael3d.Surface.prototype.updateAABB=function(){var a=this.vertices.length,b,c,d,e,f,g,h,k,l,m,n,q,r,s,t,p,u,v;h=k=l=Number.POSITIVE_INFINITY;m=n=q=Number.NEGATIVE_INFINITY;r=s=t=Number.POSITIVE_INFINITY;p=u=v=Number.NEGATIVE_INFINITY;for(var w=0;w<a;w++)b=this.vertices[w],c=b.projected,d=b.x,e=b.y,b=b.z,f=c.x,g=c.y,c=c.z,h=Math.min(d,h),k=Math.min(e,k),l=Math.min(b,l),m=Math.max(d,m),n=Math.max(e,n),q=Math.max(b,q),r=Math.min(f,r),s=Math.min(g,s),t=Math.min(c,t),p=Math.max(f,p),u=Math.max(g,u),
v=Math.max(c,v);this.aabb.setVals(h,k,l,m,n,q);this.aabbProjected.setVals(r,s,t,p,u,v);return this};Raphael3d.Surface.prototype.isInFrontOf=function(a){var b;if("Edge"==a.__type||"Face"==a.__type)return-1==a.isInFrontOfSurface(this)?!0:!1;"Surface"==a.__type&&(b=this.isInFrontOfSurface(a));return 1==b?!0:!1};Raphael3d.Surface.prototype.isInFrontOfSurface=function(a){for(var b=this.faces,c=b.length,d,e=0,f=0;f<c;f++)d=b[f].isInFrontOf(a),e+=d;return 0<e?1:0>e?-1:0};
Raphael3d.Surface.prototype.isCoveredBy=function(a){return Raphael3d.__isCoveredBy(this,a)};Raphael3d.Surface.Tetrahedron=function(a,b,c,d,e,f,g,h){var k=new Raphael3d.Vertex(a,b,c);d=new Raphael3d.Vertex(a+d,b,c);e=new Raphael3d.Vertex(a,b+e,c);a=new Raphael3d.Vertex(a,b,c+f);return Raphael3d.Surface.Tetrahedron.FromVertices(k,d,e,a,g,h)};
Raphael3d.Surface.Tetrahedron.FromVertices=function(a,b,c,d,e,f){var g=new Raphael3d.Surface([a,b,c,d],void 0,e);g.faces=[new Raphael3d.Face([a,c,b],e,f),new Raphael3d.Face([a,b,d],e,f),new Raphael3d.Face([b,c,d],e,f),new Raphael3d.Face([a,d,c],e,f)];return g};
Raphael3d.Surface.Box=function(a,b,c,d,e,f,g,h){d=a+d;var k=b+e,l=c+f;f=new Raphael3d.Vertex(a,b,l);e=new Raphael3d.Vertex(a,k,l);var m=new Raphael3d.Vertex(d,k,l),l=new Raphael3d.Vertex(d,b,l),n=new Raphael3d.Vertex(a,b,c);a=new Raphael3d.Vertex(a,k,c);k=new Raphael3d.Vertex(d,k,c);b=new Raphael3d.Vertex(d,b,c);return Raphael3d.Surface.Box.FromVertices(f,e,m,l,n,a,k,b,g,h)};
Raphael3d.Surface.Box.FromVertices=function(a,b,c,d,e,f,g,h,k,l){var m=new Raphael3d.Surface([a,b,c,d,e,f,g,h],void 0,k);m.faces=[new Raphael3d.Face([a,d,c,b],k,l),new Raphael3d.Face([e,f,g,h],k,l),new Raphael3d.Face([a,b,f,e],k,l),new Raphael3d.Face([b,c,g,f],k,l),new Raphael3d.Face([c,d,h,g],k,l),new Raphael3d.Face([d,a,e,h],k,l)];return m};
Raphael3d.Surface.Prism=function(a,b,c,d,e,f,g,h){if(3>f)return null;for(var k=Array(2*f),l,m,n=0;n<f;n++)l=2*n*Math.PI/f,m=Math.cos(-l),l=Math.sin(-l),k[n]=new Raphael3d.Vertex(a+d*m,b+d*l,c+e),k[n+f]=new Raphael3d.Vertex(a+d*m,b+d*l,c);return Raphael3d.Surface.Prism.FromVertices(k,g,h)};
Raphael3d.Surface.Prism.FromVertices=function(a,b,c){var d=new Raphael3d.Surface(a,void 0,b),e=0.5*a.length,f=Array(e+2),g,h,k;for(g=0;g<e;g++)h=g==e-1?0:g+1,k=g==e-1?e:g+e+1,h=[a[g],a[h],a[k],a[g+e]],f[g]=new Raphael3d.Face(h,b,c);h=a.slice(0,e);h.reverse();f[e]=new Raphael3d.Face(h,b,c);h=a.slice(e,2*e);f[e+1]=new Raphael3d.Face(h,b,c);d.faces=f;return d};
Raphael3d.Surface.Pyramid=function(a,b,c,d,e,f,g,h){if(3>f)return null;for(var k=Array(f+1),l,m,n=0;n<f;n++)l=2*n*Math.PI/f,m=Math.cos(l),l=Math.sin(l),k[n]=new Raphael3d.Vertex(a+d*m,b+d*l,c);k[f]=new Raphael3d.Vertex(a,b,c+e);return Raphael3d.Surface.Pyramid.FromVertices(k,g,h)};
Raphael3d.Surface.Pyramid.FromVertices=function(a,b,c){var d=new Raphael3d.Surface(a,void 0,b),e=a.length-1,f=Array(e+1),g,h,k=a[e];for(g=0;g<e;g++)h=g==e-1?0:g+1,h=[a[g],a[h],k],f[g]=new Raphael3d.Face(h,b,c);h=a.slice(0,e);h.reverse();f[e]=new Raphael3d.Face(h,b,c);d.faces=f;return d};Raphael3d.Camera=function(a,b,c,d){this.focalPoint=a||new Raphael3d.Vector3;this.dist=b||0;this.rotation=c||Raphael3d.Matrix4x4.Identity();this.zoomFactor=d||1;this.matrix=Raphael3d.Matrix4x4.Identity()};
Raphael3d.Camera.create=function(a,b,c,d){return new Raphael3d.Camera(a,b,c,d)};Raphael3d.Camera.prototype.rotateX=function(a){this.rotation.rotateX(a);return this};Raphael3d.Camera.prototype.rotateY=function(a){this.rotation.rotateY(a);return this};Raphael3d.Camera.prototype.rotateZ=function(a){this.rotation.rotateZ(a);return this};Raphael3d.Camera.prototype.zoom=function(a){this.zoomFactor*=a;return this};Raphael3d.Camera.prototype.setZoomFactor=function(a){this.zoomFactor=a;return this};
Raphael3d.Camera.prototype.resetRotations=function(){this.rotation.beIdentity();return this};Raphael3d.Camera.prototype.setFocalPoint=function(a){this.focalPoint=a;return this};Raphael3d.Camera.prototype.setDist=function(a){this.dist=a;return this};Raphael3d.Camera.prototype.update=function(){this.matrix.beIdentity();var a=this.focalPoint;this.matrix.translate(-a.x,-a.y,-a.z);this.matrix.mul(this.rotation);this.matrix.translate(0,0,this.dist/this.zoomFactor);this.matrix.zoom(this.zoomFactor);return this};
Raphael3d.Scene=function(a,b){b=b||{};this.vertices=void 0===b.vertices?[]:b.vertices.slice();this.edges=void 0===b.edges?[]:b.edges.slice();this.faces=void 0===b.faces?[]:b.faces.slice();this.surfaces=void 0===b.surfaces?[]:b.surfaces.slice();this.projection=b.projection||Raphael3d.Matrix4x4.Identity();this.camera=b.camera||new Raphael3d.Camera;this.lcs=b.lcs||Raphael3d.Matrix4x4.Identity();this.material=b.material||null;this.aabb=new Raphael3d.AABB;this.path=a?a.path().hide():null;this.renderList=
[];this.visMethod=b.visMethod||0;this.matrix=Raphael3d.Matrix4x4.Identity()};Raphael3d.Scene.create=function(a,b){return new Raphael3d.Scene(a,b)};
Raphael3d.Scene.prototype.update=function(){this.camera.update();this.matrix=this.camera.matrix.copy().mul(this.projection).mul(this.lcs);for(var a=this.vertices,b=this.vertices.length,c=this.edges,d=c.length,e=this.faces,f=e.length,g=this.surfaces,h=g.length,k=0;k<b;k++)a[k].project(this.matrix);for(k=0;k<d;k++)c[k].project(this.matrix),c[k].update();for(k=0;k<f;k++)e[k].project(this.matrix),e[k].update();for(k=0;k<h;k++)g[k].project(this.matrix),g[k].update(this.material);this.solveVisibility(this.visMethod);
return this};Raphael3d.Scene.prototype.render=function(a){if(!this.path)return this;for(var b,c=this.renderList,d=c.length,e=0;e<d;e++)b=c[e],b.path&&(b.path.insertBefore(this.path),b.render(a));return this};Raphael3d.Scene.prototype.initRenderList=function(){var a=this.edges,b=a.length,c=this.faces,d=c.length,e=this.surfaces,f=e.length,g=this.renderList,h;g.length=0;g.length=b+d+f;for(h=0;h<b;h++)g[h]=a[h];for(h=0;h<d;h++)g[b+h]=c[h];for(h=0;h<f;h++)g[b+d+h]=e[h]};
Raphael3d.Scene.prototype.solveVisibility=function(a,b){var c=this.renderList,d=c.length;switch(a){case 1:for(var e=0;e<d;e++)c[e].updateAABB();for(var f,g,e=0,h,k=0;e<d-1;){f=c[e];h=!1;for(var l=e+1;l<d;l++)if(g=c[l],!g.isProjectedZParallel()&&!f.isCoveredBy(g)&&(f.isInFrontOf(g)||g.isCoveredBy(f))){c[e]=g;c[l]=f;h=!0;break}k++;k>=d*d-e?(e+=1,k=0):h||(e+=1,k=0)}break;default:for(e=0;e<d;e++)c[e].updateAABB();for(e=0;e<d-1;e++){h=!1;for(l=e;l<d-1;l++)f=c[l],g=c[l+1],f.aabbProjected.center.z<g.aabbProjected.center.z&&
(c[l+1]=f,c[l]=g,h=!0);if(!h)break}}};Raphael3d.Scene.prototype.setCenter=function(a){a||(this.updateAABB(),this.camera.focalPoint.beCopyOf(this.aabb.center));return this};Raphael3d.Scene.prototype.addVertex=function(a){this.vertices.push(a);return this};Raphael3d.Scene.prototype.addVertices=function(a){var b=arguments.length;if(1==b&&arguments[0]instanceof Array){for(var b=arguments[0],c=b.length,d=0;d<c;d++)this.addVertex(b[d]);return this}for(d=0;d<b;d++)this.addVertex(arguments[d]);return this};
Raphael3d.Scene.prototype.addEdge=function(a){a.aabb=new Raphael3d.AABB;a.aabbProjected=new Raphael3d.AABB;this.edges.push(a);this.initRenderList();a.id="e"+this.edges.length;return this};Raphael3d.Scene.prototype.addEdges=function(a){var b=arguments.length;if(1==b&&arguments[0]instanceof Array){for(var b=arguments[0],c=b.length,d=0;d<c;d++)this.addEdge(b[d]);return this}for(d=0;d<b;d++)this.addEdge(arguments[d]);return this};
Raphael3d.Scene.prototype.addFace=function(a){a.aabb=new Raphael3d.AABB;a.aabbProjected=new Raphael3d.AABB;this.faces.push(a);this.initRenderList();a.id="f"+this.faces.length;return this};Raphael3d.Scene.prototype.addFaces=function(a){var b=arguments.length;if(1==b&&arguments[0]instanceof Array){for(var b=arguments[0],c=b.length,d=0;d<c;d++)this.addFace(b[d]);return this}for(d=0;d<b;d++)this.addFace(arguments[d]);return this};
Raphael3d.Scene.prototype.addSurface=function(a){this.surfaces.push(a);this.initRenderList();return this};Raphael3d.Scene.prototype.addSurfaces=function(a){var b=arguments.length;if(1==b&&arguments[0]instanceof Array){for(var b=arguments[0],c=b.length,d=0;d<c;d++)this.addSurface(b[d]);return this}for(d=0;d<b;d++)this.addSurface(arguments[d]);return this};Raphael3d.Scene.prototype.setMaterial=function(a){this.material=a;return this};
Raphael3d.Scene.prototype.updateAABB=function(){this.aabb.reset();var a=this.vertices,b=a.length,c=this.edges,d=c.length,e=this.faces,f=e.length,g=this.surfaces.length,h,k,l,m,n,q,r,s,t;m=n=q=Number.POSITIVE_INFINITY;r=s=t=Number.NEGATIVE_INFINITY;for(var p=0;p<b;p++)h=a[p],k=h.x,l=h.y,h=h.z,m=Math.min(k,m),n=Math.min(l,n),q=Math.min(h,q),r=Math.max(k,r),s=Math.max(l,s),t=Math.max(h,t);for(p=0;p<d;p++)a=c[p],a.updateAABB(),a=a.aabb,m=Math.min(a.minX,m),n=Math.min(a.minY,n),q=Math.min(a.minZ,q),r=
Math.max(a.maxX,r),s=Math.max(a.maxY,s),t=Math.max(a.maxZ,t);for(p=0;p<f;p++)c=e[p],c.updateAABB(),a=c.aabb,m=Math.min(a.minX,m),n=Math.min(a.minY,n),q=Math.min(a.minZ,q),r=Math.max(a.maxX,r),s=Math.max(a.maxY,s),t=Math.max(a.maxZ,t);for(p=0;p<g;p++)e=this.surfaces[p],e.updateAABB(),a=e.aabb,m=Math.min(a.minX,m),n=Math.min(a.minY,n),q=Math.min(a.minZ,q),r=Math.max(a.maxX,r),s=Math.max(a.maxY,s),t=Math.max(a.maxZ,t);this.aabb.setVals(m,n,q,r,s,t)};
Raphael3d.AABB=function(){this.center=new Raphael3d.Vector3;this.size=new Raphael3d.Vector3;this.diagonalLength=NaN;this.reset()};Raphael3d.AABB.create=function(){return new Raphael3d.AABB};Raphael3d.AABB.prototype.reset=function(){this.center.x=this.center.y=this.center.z=NaN;this.maxX=this.maxY=this.maxZ=this.minX=this.minY=this.minZ=this.size.x=this.size.y=this.size.z=NaN};
Raphael3d.AABB.prototype.update=function(){this.center.x=0.5*(this.minX+this.maxX);this.center.y=0.5*(this.minY+this.maxY);this.center.z=0.5*(this.minZ+this.maxZ);var a=this.maxX-this.minX,b=this.maxY-this.minY,c=this.maxZ-this.minZ;this.size.x=a;this.size.y=b;this.size.z=c;this.diagonalLength=Math.sqrt(a*a+b*b+c*c)};Raphael3d.AABB.prototype.setVals=function(a,b,c,d,e,f){this.minX=a;this.minY=b;this.minZ=c;this.maxX=d;this.maxY=e;this.maxZ=f;this.update()};
Raphael3d.AABB.prototype.collideWith=function(a){return this.minX<a.maxX&&this.maxX>a.minX&&this.minY<a.maxY&&this.maxY>a.minY&&this.minZ<a.maxZ&&this.maxZ>a.minZ};Raphael3d.AABB.prototype.collideXYWith=function(a){return this.minX<a.maxX&&this.maxX>a.minX&&this.minY<a.maxY&&this.maxY>a.minY};Raphael3d.MaterialColor=function(a,b,c){this.r=a||0;this.g=b||0;this.b=c||0};Raphael3d.MaterialColor.prototype.fromString=function(a){a=Raphael.getRGB(a);this.r=a.r;this.g=a.g;this.b=a.b;return this};
Raphael3d.MaterialColor.FromString=function(a){return(new Raphael3d.MaterialColor).fromString(a)};Raphael3d.Material=function(a,b,c){this.diffuseColor=Raphael3d.MaterialColor.FromString(a||"#fff");b?this.ambientColor=Raphael3d.MaterialColor.FromString(b):this.autosetAmbientColor();this.transparency=c||0};Raphael3d.Material.create=function(a,b,c){return new Raphael3d.Material(a,b,c)};
Raphael3d.Material.prototype.computeColor=function(a){a=void 0===a?1:Math.abs(a);return Raphael.rgb(this.ambientColor.r+a*(this.diffuseColor.r-this.ambientColor.r),this.ambientColor.g+a*(this.diffuseColor.g-this.ambientColor.g),this.ambientColor.b+a*(this.diffuseColor.b-this.ambientColor.b))};Raphael3d.Material.prototype.autosetAmbientColor=function(){this.ambientColor=new Raphael3d.MaterialColor(0.5*this.diffuseColor.r,0.5*this.diffuseColor.g,0.5*this.diffuseColor.b);return this};
Raphael.fn.Viewer=function(a,b,c,d,e){e=e||{};a=this.rect(a,b,c,d).attr({cursor:"move",fill:"#000",opacity:0}).attr(e);a.scene=null;a.onUpdate=function(){};a.skipBackFace=!0;a.setScene=function(a){this.scene=a;return this};a.update=function(){if(!this.scene)return this;this.scene.update();this.render();return this};a.render=function(){if(!this.scene)return this;this.scene.path&&this.scene.path.insertBefore(this);this.scene.render(this.skipBackFace);return this};a.fit=function(){if(!this.scene)return this;
this.centering();var a=this.attr(),a=Math.max(a.height,a.height),b=this.scene.aabb.diagonalLength;this.scene.camera.setZoomFactor(0.9*a/b);this.scene.camera.setDist(2*b);return this};a.centering=function(){if(!this.scene)return this;this.scene.setCenter();this.scene.lcs.beIdentity();var a=this.attr();this.scene.lcs.translate(a.x+0.5*c,a.y+0.5*d,0);return this};a.drag(function(a,b){this.scene&&(this.scene.camera.rotateY(0.01*(a-this.dx),this.scene.center),this.scene.camera.rotateX(0.01*(b-this.dy),
this.scene.center),this.update(),this.onUpdate(),this.dx=a,this.dy=b)},function(){this.dx=this.dy=0});return a};
Raphael3d.readObjFile=function(a,b,c,d){var e=new XMLHttpRequest;e.open("GET",a,!1);e.send(null);a=e.responseText.split("\n");for(var e=[],f=[],g=a.length,h,k,l,m=0;m<g;m++)"#"!=a[m].charAt(0)&&(h=a[m].split(" "),"v"==h[0]?(k=Number(h[1]),l=Number(h[2]),h=Number(h[3]),e.push(new Raphael3d.Vertex(k,l,h))):"f"==h[0]&&(k=e[h[1]-1],l=e[h[2]-1],h=e[h[3]-1],f.push(new Raphael3d.Face([k,l,h],b,c,d))));return new Raphael3d.Surface(e,f,b)};
Raphael3d.AxesCross=function(a,b,c,d,e,f,g,h){var k=new Raphael3d.Vertex(a,b,c);d=new Raphael3d.Vertex(a+d,b,c);e=new Raphael3d.Vertex(a,b+e,c);b=new Raphael3d.Vertex(a,b,c+f);a=[k,d,e,b];g=[k.connectWith(d,g,h),k.connectWith(e,g,h),k.connectWith(b,g,h)];return{vertices:a,edges:g}};Raphael3d.Geom={};Raphael3d.Geom.Line=function(a,b){this.point=a||new Raphael3d.Vector3(0,0,0);this.dir=b||new Raphael3d.Vector3(1,0,0)};Raphael3d.Geom.Line.create=function(a,b){return new Raphael3d.Geom.Line(a,b)};
Raphael3d.Geom.Line.prototype.computeIntersectionWithPlane=function(a){var b=this.point,c=this.dir,d=a.normal;a=a.d;var e=c.x*d.x+c.y*d.y+c.z*d.z;if(Math.abs(e)<Raphael3d.TOL)return null;d=(-a-d.x*b.x-d.y*b.y-d.z*b.z)/e;return new Raphael3d.Vector3(b.x+d*c.x,b.y+d*c.y,b.z+d*c.z)};
Raphael3d.Geom.Line.prototype.computeIntersectionWithAAPlane=function(a,b){b=b||0;var c,d=this.dir,e=this.point;if("x"==a){if(Math.abs(d.x)<Raphael3d.TOL)return null;c=(b-e.x)/d.x}else if("y"==a){if(Math.abs(d.y)<Raphael3d.TOL)return null;c=(b-e.y)/d.y}else if("z"==a){if(Math.abs(d.z)<Raphael3d.TOL)return null;c=(b-e.z)/d.z}else return null;return new Raphael3d.Vector3(e.x+c*d.x,e.y+c*d.y,e.z+c*d.z)};
Raphael3d.Geom.Line.prototype.fromTwoPoints=function(a,b){this.point.beCopyOf(a);this.dir.beCopyOf(b.sub(a));this.dir.normalize();return this};Raphael3d.Geom.Line.prototype.fromEdge=function(a){return this.fromTwoPoints(a.v1,a.v2)};Raphael3d.Geom.Line.FromTwoPoints=function(a,b){return(new Raphael3d.Geom.Line).fromTwoPoints(a,b)};Raphael3d.Geom.Line.FromEdge=function(a){return(new Raphael3d.Geom.Line).fromEdge(a)};Raphael3d.Geom.Plane=function(){this.normal=new Raphael3d.Vector3(1,0,0);this.d=0};
Raphael3d.Geom.Plane.create=function(){return new Raphael3d.Geom.Plane};Raphael3d.Geom.Plane.prototype.containsPoint=function(a){var b=this.normal;return Math.abs(b.x*a.x+b.y*a.y+b.z*a.z+this.d)<Raphael3d.TOL};Raphael3d.Geom.Plane.prototype.fromThreePoints=function(a,b,c){b=b.sub(a);c=c.sub(a);this.normal=b.cross(c);this.normal.normalize();this.d=-this.normal.x*a.x-this.normal.y*a.y-this.normal.z*a.z;return this};Raphael3d.Geom.Plane.prototype.computeIntersectionWithLine=function(a){return a.computeIntersectionWithPlane(this)};
Raphael3d.Geom.Plane.prototype.fromFace=function(a){a=a.vertices;return this.fromThreePoints(a[0],a[1],a[a.length-1])};Raphael3d.Geom.Plane.FromThreePoints=function(a,b,c){return(new Raphael3d.Geom.Plane).fromThreePoints(a,b,c)};Raphael3d.Geom.Plane.FromFace=function(a){return(new Raphael3d.Geom.Plane).fromFace(a)};
Raphael3d.Geom.Plane.prototype.isEqualTo=function(a){var b=this.normal,c=Math.abs(b.x),d=Math.abs(b.y),e=Math.abs(b.z),d=c>d&&c>e?"x":d>c&&d>e?"y":"z",c=a.normal,d=c[d]/b[d];return Math.abs(c.x/b.x-d)<Raphael3d.TOL&&Math.abs(c.y/b.y-d)<Raphael3d.TOL&&Math.abs(c.z/b.z-d)<Raphael3d.TOL&&Math.abs(this.d/a.d-d)<Raphael3d.TOL};Raphael3d.Geom.OrientedLine2d=function(a,b){this.point=a||{x:0,y:0};this.dir=b||{x:1,y:0}};
Raphael3d.Geom.OrientedLine2d.create=function(a,b){return new Raphael3d.Geom.OrientedLine2d(a,b)};Raphael3d.Geom.OrientedLine2d.prototype.hasIntersectionWithProjEdge=function(a){var b=a.v1.projected;a=a.v2.projected;b=Raphael3d.Geom.compute2dEdgeEdgeIntersection(this.point,this.dir,b,{x:a.x-b.x,y:a.y-b.y});if(!b||b.parallel)return!1;a=b.param2;var c=Raphael3d.TOL;return b.param1>=-c&&a>=-c&&a<=1+c};
Raphael3d.Geom.compute2dEdgeEdgeIntersection=function(a,b,c,d){var e,f,g=!1;if(Math.abs(b.x)<Raphael3d.TOL){if(Math.abs(d.x)<Raphael3d.TOL){if(Math.abs(a.x-c.x)>Raphael3d.TOL)return null;g=!0}e=(a.x-c.x)/d.x;f=(c.y-a.y+e*d.y)/b.y}else if(Math.abs(b.y)<Raphael3d.TOL){if(Math.abs(d.y)<Raphael3d.TOL){if(Math.abs(a.y-c.y)>Raphael3d.TOL)return null;g=!0}e=(a.y-c.y)/d.y;f=(c.x-a.x+e*d.x)/b.x}else Math.abs(b.y/b.x*d.x-d.y)<Raphael3d.TOL?(f=-a.x/b.x,e=-c.x/d.x,g=!0):(e=(c.y-a.y-b.y/b.x*(c.x-a.x))/(b.y/b.x*
d.x-d.y),f=(c.x-a.x+e*d.x)/b.x);return{param1:f,param2:e,x:a.x+f*b.x,y:a.y+f*b.y,parallel:g}};Raphael3d.temp={line:new Raphael3d.Geom.Line,plane:new Raphael3d.Geom.Plane};
